﻿using System;

namespace ET
{
    [FriendClass(typeof (Unit))]
    public class C2M_FarmlandPlantHandler: AMActorLocationRpcHandler<Unit, C2M_FarmlandPlant, M2C_FarmlandPlant>
    {
        protected override async ETTask Run(Unit unit, C2M_FarmlandPlant request, M2C_FarmlandPlant response, Action reply)
        {
            try
            {
               
                Farmland farmland = unit.GetGrandChild<Farmland>(request.FarmlandId);
                if (farmland!=null)
                {
                    People people = unit.GetComponent<PeopleComponent>().GetChild<People>(request.PeopleId);
                    if (people != null)
                    {
                        response.Error = FarmlandOperate.FinishPlant(unit, farmland, people);
                    }
                    else
                    {
                        response.Error = ErrorCode.ERR_PeopleNotFound;
                    }
                }
                else
                {
                    response.Error = ErrorCode.ERR_FarmlandNotFound;
                }

                reply();
            }
            catch (Exception e)
            {
                response.Message = e.ToString();
                response.Error = ErrorCode.ERR_OperateFail;
                reply();
                throw;
            }

            await ETTask.CompletedTask;
        }
    }
}