﻿using System;

namespace ET
{

    [ActorMessageHandler]
    [FriendClass(typeof(Unit))]
    public class C2M_GameTimedHandler: AMActorLocationRpcHandler<Unit, C2M_GameTime, M2C_GameTime>
    {
        protected async override ETTask Run(Unit unit, C2M_GameTime request, M2C_GameTime response, Action reply)
        {

            try
            {
                response.GameTime = unit.GameTime;
                reply();
            }
            catch (Exception e)
            {
                response.Error = ErrorCode.ERR_BuildError;
                response.Message = e.ToString();
                reply();
            }
            await ETTask.CompletedTask;
        }
    }
}