using System;
using System.Collections.Generic;

namespace PVSkill
{
    public class SkillSetConfigCategory : IConfigCategory
    {
        public static SkillSetConfigCategory Instance;
        public List<SkillSetConfig> list = new List<SkillSetConfig>();
        private Dictionary<int, SkillSetConfig> dict = new Dictionary<int, SkillSetConfig>();
        
        public SkillSetConfigCategory()
        {
            Instance = this;
        }
        
        public void Init()
        {
            foreach (SkillSetConfig config in list)
            {
                this.dict.Add(config.Id, config);
            } 
        }
        
        public SkillSetConfig Get(int id)
        {
            this.dict.TryGetValue(id, out SkillSetConfig item);

            if (item == null)
            {
                throw new Exception($"配置找不到，配置表名: {nameof (SkillSetConfig)}，配置id: {id}");
            }

            return item;
        }
    }


    public class SkillSetConfig
    {
        public int Id
        {
            get
            {
                return _id;
            }
        }
		public int _id; 
		public int Weapon { get; set; }
		public int Type { get; set; }
		public int RankOne { get; set; }
		public int RankTwo { get; set; }
		public int RankThree { get; set; }
		public int RankFour { get; set; }
		public int RankMax { get; set; }
		public int RankMaxCD { get; set; }
		public int RankMaxCost { get; set; }
  
    }
}