using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using PVSkill;
using LitJson;
using UnityEditor;
using UnityEngine;

public static class SkillEditorMenu
{
    static string jsonDir = Application.dataPath + "../../../Bin/Json/c";
    
    [MenuItem("Tools/SkillEditor")]
    public static void SkillEditorWindow()
    {
        LoadConfig<SkillFatherConfigCategory>();
        Debug.LogError(SkillFatherConfigCategory.Instance.Get(1).SkillName);
    }

    private static void LoadConfig<T>() where T: IConfigCategory
    {
        string categoryName = typeof (T).Name;
        string configName = categoryName.Substring(0, categoryName.Length - 8);
        string path = Path.Combine(jsonDir, $"{configName}.txt");
        string data = File.ReadAllText(path);
        var configCategory = JsonMapper.ToObject<T>(data);
        configCategory.Init();
    }
}
