using System;
using System.Collections.Generic;
using System.Reflection;

namespace ILRuntime.Runtime.Generated
{
    class CLRBindings
    {

//will auto register in unity
#if UNITY_5_3_OR_NEWER
        [UnityEngine.RuntimeInitializeOnLoadMethod(UnityEngine.RuntimeInitializeLoadType.BeforeSceneLoad)]
#endif
        static private void RegisterBindingAction()
        {
            ILRuntime.Runtime.CLRBinding.CLRBindingUtils.RegisterBindingAction(Initialize);
        }

        internal static ILRuntime.Runtime.Enviorment.ValueTypeBinder<UnityEngine.Vector2> s_UnityEngine_Vector2_Binding_Binder = null;
        internal static ILRuntime.Runtime.Enviorment.ValueTypeBinder<UnityEngine.Vector3> s_UnityEngine_Vector3_Binding_Binder = null;
        internal static ILRuntime.Runtime.Enviorment.ValueTypeBinder<UnityEngine.Quaternion> s_UnityEngine_Quaternion_Binding_Binder = null;

        /// <summary>
        /// Initialize the CLR binding, please invoke this AFTER CLR Redirection registration
        /// </summary>
        public static void Initialize(ILRuntime.Runtime.Enviorment.AppDomain app)
        {
            FairyGUI_GTextField_Binding.Register(app);
            FairyGUI_TextFormat_Binding.Register(app);
            System_Int64_Binding.Register(app);
            FairyGUI_GObject_Binding.Register(app);
            FairyGUI_GLoader_Binding.Register(app);
            UnityEngine_Vector2_Binding.Register(app);
            UnityEngine_Random_Binding.Register(app);
            FairyGUI_GComponent_Binding.Register(app);
            FairyGUI_GTween_Binding.Register(app);
            FairyGUI_GTweener_Binding.Register(app);
            System_String_Binding.Register(app);
            UnityEngine_Mathf_Binding.Register(app);
            UnityEngine_Object_Binding.Register(app);
            UnityEngine_Transform_Binding.Register(app);
            UnityEngine_Vector3_Binding.Register(app);
            UnityEngine_Camera_Binding.Register(app);
            UnityEngine_Screen_Binding.Register(app);
            FairyGUI_GRoot_Binding.Register(app);
            FairyGUI_TweenValue_Binding.Register(app);
            System_Collections_Generic_Stack_1_ET_GComponentAdapter_Binding_Adapter_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_ILTypeInstance_Binding.Register(app);
            ET_TimeHelper_Binding.Register(app);
            ET_ETAsyncTaskMethodBuilder_Binding.Register(app);
            ET_Log_Binding.Register(app);
            ET_ETTask_1_Boolean_Binding.Register(app);
            ET_ETTask_1_Int32_Binding.Register(app);
            System_Collections_Generic_List_1_ILTypeInstance_Binding.Register(app);
            System_Collections_Generic_List_1_ILTypeInstance_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int64_ILTypeInstance_Binding.Register(app);
            System_IDisposable_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_ILTypeInstance_Binding_ValueCollection_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_ILTypeInstance_Binding_ValueCollection_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_Queue_1_ILTypeInstance_Binding.Register(app);
            System_Linq_Enumerable_Binding.Register(app);
            System_Int32_Binding.Register(app);
            ET_RandomHelper_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_ILTypeInstance_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_KeyValuePair_2_Int32_ILTypeInstance_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_List_1_ILTypeInstance_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int64_ILTypeInstance_Binding_ValueCollection_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int64_ILTypeInstance_Binding_ValueCollection_Binding_Enumerator_Binding.Register(app);
            System_ValueTuple_2_Int32_Single_Binding.Register(app);
            System_Math_Binding.Register(app);
            System_Int32_Array2_Binding.Register(app);
            NCalc_Expression_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_Object_Binding.Register(app);
            System_Convert_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_Int32_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_Int32_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_KeyValuePair_2_Int32_Int32_Binding.Register(app);
            System_ValueTuple_2_Int32_Int32_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int64_ILTypeInstance_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_KeyValuePair_2_Int64_ILTypeInstance_Binding.Register(app);
            System_Array_Binding.Register(app);
            System_Collections_Generic_List_1_Int64_Binding.Register(app);
            System_Collections_Generic_List_1_Int64_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_List_1_Int32_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_ILTypeInstance_Binding_KeyCollection_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_ILTypeInstance_Binding_KeyCollection_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_Int64_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_Int64_Binding_KeyCollection_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_Int64_Binding_KeyCollection_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_Int64_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_KeyValuePair_2_Int32_Int64_Binding.Register(app);
            ET_ETAsyncTaskMethodBuilder_1_Int32_Binding.Register(app);
            ET_ETTask_1_ILTypeInstance_Binding.Register(app);
            ET_ETTask_Binding.Register(app);
            ET_ETTaskCompleted_Binding.Register(app);
            System_Object_Binding.Register(app);
            System_Console_Binding.Register(app);
            ET_NetworkHelper_Binding.Register(app);
            ET_MD5Helper_Binding.Register(app);
            ET_ListComponent_1_Vector3_Binding.Register(app);
            System_Collections_Generic_List_1_Single_Binding.Register(app);
            System_Collections_Generic_List_1_Vector3_Binding.Register(app);
            UnityEngine_Quaternion_Binding.Register(app);
            ET_ETAsyncTaskMethodBuilder_1_Boolean_Binding.Register(app);
            System_Action_1_Boolean_Binding.Register(app);
            System_Collections_Generic_List_1_Vector3_Binding_Enumerator_Binding.Register(app);
            ET_ETCancellationToken_Binding.Register(app);
            System_ValueTuple_2_Int32_Int64_Binding.Register(app);
            System_Collections_Generic_List_1_String_Binding.Register(app);
            System_ValueTuple_2_Boolean_Int32_Binding.Register(app);
            System_IO_MemoryStream_Binding.Register(app);
            System_BitConverter_Binding.Register(app);
            System_Collections_Generic_List_1_Int32_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_SortedDictionary_2_Int32_ILTypeInstance_Binding.Register(app);
            System_Collections_Generic_SortedDictionary_2_Int32_ILTypeInstance_Binding.Register(app);
            System_Collections_Generic_SortedDictionary_2_Int32_ILTypeInstance_Binding_ValueCollection_Binding.Register(app);
            System_Collections_Generic_SortedDictionary_2_Int32_ILTypeInstance_Binding_ValueCollection_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_ILTypeInstance_Binding.Register(app);
            System_Type_Binding.Register(app);
            System_Collections_Generic_List_1_Type_Binding.Register(app);
            System_Collections_Generic_List_1_Type_Binding_Enumerator_Binding.Register(app);
            System_Activator_Binding.Register(app);
            System_Reflection_MemberInfo_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Type_Object_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_Byte_Array_Binding.Register(app);
            System_Threading_Monitor_Binding.Register(app);
            ET_ListComponent_1_Task_Binding.Register(app);
            System_Threading_Tasks_Task_Binding.Register(app);
            System_Collections_Generic_List_1_Task_Binding.Register(app);
            System_Runtime_CompilerServices_TaskAwaiter_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_UInt16_List_1_ILTypeInstance_Binding.Register(app);
            ET_TService_Binding.Register(app);
            ET_AService_Binding.Register(app);
            ET_ThreadSynchronizationContext_Binding.Register(app);
            ET_ForeachHelper_Binding.Register(app);
            System_Collections_Generic_HashSet_1_AService_Binding.Register(app);
            System_Exception_Binding.Register(app);
            ET_TimeInfo_Binding.Register(app);
            ET_RpcException_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_Int64_Binding.Register(app);
            System_Func_2_String_Byte_Array_Binding.Register(app);
            ET_Recast_Binding.Register(app);
            ET_MathHelper_Binding.Register(app);
            DG_Tweening_ShortcutExtensions_Binding.Register(app);
            System_Collections_Generic_List_1_Tweener_Binding.Register(app);
            System_Collections_Generic_List_1_AnimancerState_Binding.Register(app);
            System_Collections_Generic_List_1_AnimancerState_Binding_Enumerator_Binding.Register(app);
            Animancer_AnimancerState_Binding.Register(app);
            Animancer_AnimancerNode_Binding.Register(app);
            System_ValueTuple_2_AnimancerState_Single_Binding.Register(app);
            UnityEngine_GameObject_Binding.Register(app);
            DG_Tweening_TweenSettingsExtensions_Binding.Register(app);
            Animancer_AnimancerComponent_Binding.Register(app);
            UnityEngine_AnimationClip_Binding.Register(app);
            Animancer_SimpleEventReceiver_Binding.Register(app);
            Animancer_AnimationEventReceiver_Binding.Register(app);
            UnityEngine_AnimationEvent_Binding.Register(app);
            Animancer_AnimancerEvent_Binding_Sequence_Binding.Register(app);
            UnityEngine_Time_Binding.Register(app);
            ReferenceCollector_Binding.Register(app);
            UnityEngine_Component_Binding.Register(app);
            UnityEngine_EventSystems_EventTrigger_Binding_Entry_Binding.Register(app);
            UnityEngine_Events_UnityEvent_1_BaseEventData_Binding.Register(app);
            UnityEngine_EventSystems_EventTrigger_Binding.Register(app);
            System_Collections_Generic_List_1_UnityEngine_EventSystems_EventTrigger_Binding_Entry_Binding.Register(app);
            ParticleController_Binding.Register(app);
            UnityEngine_Color_Binding.Register(app);
            UnityEngine_SpriteRenderer_Binding.Register(app);
            UnityEngine_Physics2D_Binding.Register(app);
            FairyGUI_Stage_Binding.Register(app);
            UnityEngine_Renderer_Binding.Register(app);
            UnityEngine_Bounds_Binding.Register(app);
            UnityEngine_Shader_Binding.Register(app);
            UnityEngine_Material_Binding.Register(app);
            UnityEngine_Mesh_Binding.Register(app);
            UnityEngine_MeshFilter_Binding.Register(app);
            UnityEngine_Vector2Int_Binding.Register(app);
            UnityEngine_AI_NavMeshModifier_Binding.Register(app);
            UnityEngine_Sprites_DataUtility_Binding.Register(app);
            UnityEngine_Debug_Binding.Register(app);
            FairyGUI_Window_Binding.Register(app);
            FairyGUI_UIObjectFactory_Binding.Register(app);
            FairyGUI_GList_Binding.Register(app);
            FairyGUI_EventListener_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int64_ET_GButtonAdapter_Binding_Adapter_Binding.Register(app);
            FairyGUI_GButton_Binding.Register(app);
            FairyGUI_GProgressBar_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int64_ET_GButtonAdapter_Binding_Adapter_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_KeyValuePair_2_Int64_ET_GButtonAdapter_Binding_Adapter_Binding.Register(app);
            FairyGUI_Controller_Binding.Register(app);
            FairyGUI_EventContext_Binding.Register(app);
            System_Action_Binding.Register(app);
            System_Runtime_CompilerServices_AsyncVoidMethodBuilder_Binding.Register(app);
            System_UInt32_Binding.Register(app);
            System_Reflection_FieldInfo_Binding.Register(app);
            FairyGUI_GSlider_Binding.Register(app);
            System_Double_Binding.Register(app);
            FairyGUI_EventCallback0_Binding.Register(app);
            UnityEngine_ColorUtility_Binding.Register(app);
            FairyGUI_GImage_Binding.Register(app);
            System_Text_StringBuilder_Binding.Register(app);
            FairyGUI_Transition_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_Int32_Binding_KeyCollection_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_Int32_Binding_KeyCollection_Binding_Enumerator_Binding.Register(app);
            FairyGUI_GLabel_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_ET_GButtonAdapter_Binding_Adapter_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_ET_GButtonAdapter_Binding_Adapter_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_KeyValuePair_2_Int32_ET_GButtonAdapter_Binding_Adapter_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int64_Int32_Binding.Register(app);
            FairyGUI_DragDropManager_Binding.Register(app);
            FairyGUI_GoWrapper_Binding.Register(app);
            FairyGUI_GGraph_Binding.Register(app);
            FairyGUI_GTextInput_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_List_1_Int32_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_List_1_Int32_Binding_KeyCollection_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_List_1_Int32_Binding_KeyCollection_Binding_Enumerator_Binding.Register(app);
            UnityEngine_LayerMask_Binding.Register(app);
            ET_InputHelper_Binding.Register(app);
            UnityEngine_Input_Binding.Register(app);
            UnityEngine_Physics_Binding.Register(app);
            UnityEngine_RaycastHit_Binding.Register(app);
            ET_CodeLoader_Binding.Register(app);
            FairyGUI_DisplayObject_Binding.Register(app);
            FairyGUI_InputEvent_Binding.Register(app);
            UnityEngine_Sprite_Binding.Register(app);
            UnityEngine_Vector4_Binding.Register(app);
            FairyGUI_SwipeGesture_Binding.Register(app);
            FairyGUI_PinchGesture_Binding.Register(app);
            UnityEngine_AI_NavMeshAgent_Binding.Register(app);
            ET_ETAsyncTaskMethodBuilder_1_GameObject_Binding.Register(app);
            ET_ETTask_1_GameObject_Binding.Register(app);
            YooAsset_YooAssetWrapper_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_List_1_GameObject_Binding.Register(app);
            System_Collections_Generic_List_1_GameObject_Binding.Register(app);
            System_Collections_Generic_List_1_GameObject_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_List_1_Object_Binding.Register(app);
            System_Collections_Generic_List_1_Object_Binding.Register(app);
            System_Collections_Generic_List_1_Object_Binding_Enumerator_Binding.Register(app);
            FairyGUI_UIConfig_Binding.Register(app);
            UnityEngine_Collider2D_Binding.Register(app);
            UnityEngine_BoxCollider2D_Binding.Register(app);
            System_Boolean_Array2_Binding.Register(app);
            UnityEngine_AI_NavMeshSurface2d_Binding.Register(app);
            UnityEngine_PolygonCollider2D_Binding.Register(app);
            UnityEngine_AsyncOperation_Binding.Register(app);
            UnityEngine_Animator_Binding.Register(app);
            UnityEngine_RuntimeAnimatorController_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_AnimationClip_Binding.Register(app);
            UnityEngine_AnimatorControllerParameter_Binding.Register(app);
            System_Collections_Generic_HashSet_1_String_Binding.Register(app);
            ET_ETAsyncTaskMethodBuilder_1_ILTypeInstance_Binding.Register(app);
            FairyGUI_UIPackage_Binding.Register(app);
            System_Func_1_ETTask_Binding.Register(app);
            System_Func_2_EventContext_ETTask_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_UIPackage_Binding.Register(app);
            ET_Define_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_List_1_Object_Binding.Register(app);
            UnityEngine_TextAsset_Binding.Register(app);
            ET_ETTask_1_Object_Binding.Register(app);
            FairyGUI_PackageItem_Binding.Register(app);
            ET_ETTask_1_TextAsset_Binding.Register(app);
            UnityEngine_PlayerPrefs_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_SoundData_Binding.Register(app);
            ET_SoundData_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_SoundType_Dictionary_2_String_SoundData_Binding.Register(app);
            UnityEngine_AudioSource_Binding.Register(app);
            ET_ETAsyncTaskMethodBuilder_1_SoundData_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_SoundType_Dictionary_2_String_SoundData_Binding_ValueCollection_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_SoundType_Dictionary_2_String_SoundData_Binding_ValueCollection_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_SoundData_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_KeyValuePair_2_String_SoundData_Binding.Register(app);
            ET_ETTask_1_SoundData_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_Transform_Binding.Register(app);
            ET_Options_Binding.Register(app);
            System_Collections_Generic_List_1_Action_Binding.Register(app);
            System_Collections_Generic_List_1_Action_Binding_Enumerator_Binding.Register(app);
            ET_MonoPool_Binding.Register(app);
            LitJson_JsonMapper_Binding.Register(app);
            System_Collections_Generic_HashSet_1_ILTypeInstance_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Type_ILTypeInstance_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_Type_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_Type_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_KeyValuePair_2_String_Type_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Type_List_1_Type_Binding.Register(app);
            ET_UnOrderMultiMap_2_Type_Type_Binding.Register(app);
            ET_UnOrderMultiMap_2_Type_Object_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Type_List_1_Object_Binding.Register(app);
            System_Collections_Generic_List_1_Object_Binding_t1.Register(app);
            System_Reflection_Assembly_Binding.Register(app);
            System_Reflection_AssemblyName_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_Assembly_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_Assembly_Binding_ValueCollection_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_Assembly_Binding_ValueCollection_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_Queue_1_Int64_Binding.Register(app);
            ET_ObjectHelper_Binding.Register(app);
            System_Collections_Generic_HashSet_1_Type_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Type_Int32_Binding.Register(app);
            System_Collections_Generic_HashSet_1_Type_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_IEnumerable_1_KeyValuePair_2_Type_Int32_Binding.Register(app);
            System_Collections_Generic_IEnumerator_1_KeyValuePair_2_Type_Int32_Binding.Register(app);
            System_Collections_Generic_KeyValuePair_2_Type_Int32_Binding.Register(app);
            System_Collections_IEnumerator_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Type_UnOrderMultiMap_2_Type_Object_Binding.Register(app);
            System_DateTime_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Type_Queue_1_ILTypeInstance_Binding.Register(app);
            ProtoBuf_Meta_RuntimeTypeModel_Binding.Register(app);
            ProtoBuf_Meta_TypeModel_Binding.Register(app);
            ProtoBuf_Serializer_Binding.Register(app);
            ET_MultiMap_2_Int64_Int64_Binding.Register(app);
            System_Collections_Generic_SortedDictionary_2_Int64_List_1_Int64_Binding.Register(app);
            System_Random_Binding.Register(app);
            System_Byte_Binding.Register(app);
            System_ArgumentException_Binding.Register(app);
            System_Collections_Hashtable_Binding.Register(app);
            System_Guid_Binding.Register(app);
            System_Collections_Generic_List_1_Int32_Array_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_Int32_Array_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_Dictionary_2_Int32_Int32_Array_Binding.Register(app);
            System_ValueTuple_3_Int32_Int64_Int32_Binding.Register(app);
            System_Collections_Generic_Queue_1_ValueTuple_3_Int32_Int64_Int32_Binding.Register(app);
            ET_MultiMap_2_Int64_ILTypeInstance_Binding.Register(app);
            System_Collections_Generic_SortedDictionary_2_Int64_List_1_ILTypeInstance_Binding.Register(app);
            System_IO_Stream_Binding.Register(app);
            ET_ByteHelper_Binding.Register(app);
            ET_StringHelper_Binding.Register(app);
            System_ValueTuple_2_UInt16_MemoryStream_Binding.Register(app);
            System_Collections_Generic_HashSet_1_UInt16_Binding.Register(app);
            ET_ILog_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Type_UInt16_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_UInt16_Type_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Type_Type_Binding.Register(app);
            ET_ErrorCore_Binding.Register(app);
            System_Single_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_Object_Binding_t1.Register(app);
            System_Collections_Generic_Dictionary_2_String_Object_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_KeyValuePair_2_String_Object_Binding.Register(app);
            System_Action_1_ET_GComponentAdapter_Binding_Adapter_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int64_GameObject_Binding.Register(app);
            UnityEngine_AssetBundle_Binding.Register(app);
            ET_ETAsyncTaskMethodBuilder_1_AssetBundle_Binding.Register(app);
            ET_ETAsyncTaskMethodBuilder_1_Object_Array_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_Int32_String_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_String_Binding.Register(app);
            UnityEngine_AssetBundleCreateRequest_Binding.Register(app);
            ET_ETTask_1_AssetBundle_Binding.Register(app);
            UnityEngine_AssetBundleRequest_Binding.Register(app);
            ET_ETTask_1_Object_Array_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_String_Array_Binding.Register(app);
            UnityEngine_AssetBundleManifest_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_Int32_Binding.Register(app);
            System_Collections_Generic_List_1_String_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_Dictionary_2_String_Object_Binding.Register(app);
            System_IO_Path_Binding.Register(app);
            ET_PathHelper_Binding.Register(app);
            System_IO_File_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_ILTypeInstance_Binding_ValueCollection_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_ILTypeInstance_Binding_ValueCollection_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_ILTypeInstance_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_KeyValuePair_2_String_ILTypeInstance_Binding.Register(app);
            System_Collections_Generic_KeyValuePair_2_String_Int32_Binding.Register(app);
            ET_ListComponent_1_ILTypeInstance_Binding.Register(app);
            ET_ListComponent_1_ETTask_Binding.Register(app);
            System_Collections_Generic_List_1_ETTask_Binding.Register(app);
            ET_ETTaskHelper_Binding.Register(app);
            ET_ListComponent_1_String_Binding.Register(app);
            FairyGUI_NTexture_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_NTexture_Sprite_Binding.Register(app);
            UnityEngine_Rect_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_GObject_ILTypeInstance_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_SoundData_Binding_ValueCollection_Binding.Register(app);
            System_Collections_Generic_Dictionary_2_String_SoundData_Binding_ValueCollection_Binding_Enumerator_Binding.Register(app);
            System_Collections_Generic_Stack_1_PoolObject_Binding.Register(app);
            ET_PoolObject_Binding.Register(app);
            ET_WrapVector3_Binding.Register(app);

            ILRuntime.CLR.TypeSystem.CLRType __clrType = null;
            __clrType = (ILRuntime.CLR.TypeSystem.CLRType)app.GetType (typeof(UnityEngine.Vector2));
            s_UnityEngine_Vector2_Binding_Binder = __clrType.ValueTypeBinder as ILRuntime.Runtime.Enviorment.ValueTypeBinder<UnityEngine.Vector2>;
            __clrType = (ILRuntime.CLR.TypeSystem.CLRType)app.GetType (typeof(UnityEngine.Vector3));
            s_UnityEngine_Vector3_Binding_Binder = __clrType.ValueTypeBinder as ILRuntime.Runtime.Enviorment.ValueTypeBinder<UnityEngine.Vector3>;
            __clrType = (ILRuntime.CLR.TypeSystem.CLRType)app.GetType (typeof(UnityEngine.Quaternion));
            s_UnityEngine_Quaternion_Binding_Binder = __clrType.ValueTypeBinder as ILRuntime.Runtime.Enviorment.ValueTypeBinder<UnityEngine.Quaternion>;
        }

        /// <summary>
        /// Release the CLR binding, please invoke this BEFORE ILRuntime Appdomain destroy
        /// </summary>
        public static void Shutdown(ILRuntime.Runtime.Enviorment.AppDomain app)
        {
            s_UnityEngine_Vector2_Binding_Binder = null;
            s_UnityEngine_Vector3_Binding_Binder = null;
            s_UnityEngine_Quaternion_Binding_Binder = null;
        }
    }
}
