using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Runtime.InteropServices;

using ILRuntime.CLR.TypeSystem;
using ILRuntime.CLR.Method;
using ILRuntime.Runtime.Enviorment;
using ILRuntime.Runtime.Intepreter;
using ILRuntime.Runtime.Stack;
using ILRuntime.Reflection;
using ILRuntime.CLR.Utils;

namespace ILRuntime.Runtime.Generated
{
    unsafe class ET_PoolObject_Binding
    {
        public static void Register(ILRuntime.Runtime.Enviorment.AppDomain app)
        {
            BindingFlags flag = BindingFlags.Public | BindingFlags.Instance | BindingFlags.Static | BindingFlags.DeclaredOnly;
            FieldInfo field;
            Type[] args;
            Type type = typeof(ET.PoolObject);

            field = type.GetField("isPooled", flag);
            app.RegisterCLRFieldGetter(field, get_isPooled_0);
            app.RegisterCLRFieldSetter(field, set_isPooled_0);
            app.RegisterCLRFieldBinding(field, CopyToStack_isPooled_0, AssignFromStack_isPooled_0);
            field = type.GetField("poolName", flag);
            app.RegisterCLRFieldGetter(field, get_poolName_1);
            app.RegisterCLRFieldSetter(field, set_poolName_1);
            app.RegisterCLRFieldBinding(field, CopyToStack_poolName_1, AssignFromStack_poolName_1);


        }



        static object get_isPooled_0(ref object o)
        {
            return ((ET.PoolObject)o).isPooled;
        }

        static StackObject* CopyToStack_isPooled_0(ref object o, ILIntepreter __intp, StackObject* __ret, IList<object> __mStack)
        {
            var result_of_this_method = ((ET.PoolObject)o).isPooled;
            __ret->ObjectType = ObjectTypes.Integer;
            __ret->Value = result_of_this_method ? 1 : 0;
            return __ret + 1;
        }

        static void set_isPooled_0(ref object o, object v)
        {
            ((ET.PoolObject)o).isPooled = (System.Boolean)v;
        }

        static StackObject* AssignFromStack_isPooled_0(ref object o, ILIntepreter __intp, StackObject* ptr_of_this_method, IList<object> __mStack)
        {
            ILRuntime.Runtime.Enviorment.AppDomain __domain = __intp.AppDomain;
            System.Boolean @isPooled = ptr_of_this_method->Value == 1;
            ((ET.PoolObject)o).isPooled = @isPooled;
            return ptr_of_this_method;
        }

        static object get_poolName_1(ref object o)
        {
            return ((ET.PoolObject)o).poolName;
        }

        static StackObject* CopyToStack_poolName_1(ref object o, ILIntepreter __intp, StackObject* __ret, IList<object> __mStack)
        {
            var result_of_this_method = ((ET.PoolObject)o).poolName;
            return ILIntepreter.PushObject(__ret, __mStack, result_of_this_method);
        }

        static void set_poolName_1(ref object o, object v)
        {
            ((ET.PoolObject)o).poolName = (System.String)v;
        }

        static StackObject* AssignFromStack_poolName_1(ref object o, ILIntepreter __intp, StackObject* ptr_of_this_method, IList<object> __mStack)
        {
            ILRuntime.Runtime.Enviorment.AppDomain __domain = __intp.AppDomain;
            System.String @poolName = (System.String)typeof(System.String).CheckCLRTypes(StackObject.ToObject(ptr_of_this_method, __domain, __mStack), (CLR.Utils.Extensions.TypeFlags)0);
            ((ET.PoolObject)o).poolName = @poolName;
            return ptr_of_this_method;
        }



    }
}
