﻿using System.Collections.Generic;
using FairyGUI;

namespace ET
{
    public class FUIManager_Mono
    {
        public static Dictionary<string, GComponent> AllFUIs = new Dictionary<string, GComponent>();

        public static void AddUI(string name, GComponent gComponent)
        {
            AllFUIs[name] = gComponent;
            GRoot.inst.AddChild(gComponent);
        }

        public static T GetUI<T>(string name) where T : GComponent
        {
            return AllFUIs[name] as T;
        }

        public static void RemoveUI(string name)
        {
            if (AllFUIs.ContainsKey(name))
            {
                AllFUIs[name].Dispose();
                AllFUIs.Remove(name);               
            }
        }
    }
}