﻿using System.Runtime.CompilerServices;

namespace ET
{
    [FriendClass(typeof(Cuisine))]
    public static class CuisineComponentSystem
    {
        public static Cuisine StartCuisine(this CuisineComponent self, int configId)
        {
            Cuisine cuisine = self.AddChildWithId<Cuisine>(0);
            cuisine.ConfigId = configId;
            cuisine.Progress = 0;
            return cuisine;
        }

        public static void Update(this CuisineComponent self, Unit unit, long tick)
        {
            Cuisine cuisine = self.GetChild<Cuisine>(0);
            if (cuisine == null)
            {
                return;
            }

            cuisine.Progress += (int) tick;
            if (cuisine.Progress >= 35)
            {
                CuisineOperate.EndCuisine(unit, 0);
                cuisine.Dispose();
            }
        }

        public static bool checkCuisine(this CuisineComponent self)
        {
            Cuisine cuisine = self.GetChild<Cuisine>(0);
            return cuisine != null;
        }
    }
}