﻿using DG.Tweening;
using UnityEngine;

namespace ET
{
    public class BattleAction_MoveToTargetAwakeSystem: AwakeSystem<BattleAction_MoveToTarget>
    {
        public override void Awake(BattleAction_MoveToTarget self)
        {
            self.Awake();
        }
    }
    
    public class BattleAction_MoveToTargetDestroySystem: DestroySystem<BattleAction_MoveToTarget>
    {
        public override void Destroy(BattleAction_MoveToTarget self)
        {
            self.Destroy();
        }
    }
    
    [FriendClass(typeof(BattleActionSegment))]
    [FriendClass(typeof(BattleAction_MoveToTarget))]
    public static class BattleAction_MoveToTargetSystem
    {
        public static void Awake(this BattleAction_MoveToTarget self)
        {

        }

        public static void MoveTo(this BattleAction_MoveToTarget self, Transform sourceTransform, Vector3 targetPos)
        {
            var segment = self.GetParent<BattleActionSegment>();

            sourceTransform.DOMove(targetPos, segment.TotalTime);
        }

        public static void AddTweener(this BattleAction_MoveToTarget self, Tweener tweener)
        {
            self.MoveTweeners.Add(tweener);
        }

        public static void Destroy(this BattleAction_MoveToTarget self)
        {
            // foreach (Tweener tweener in self.MoveTweeners)
            // {
            //     tweener.Kill(true);
            // }
            
            self.MoveTweeners.Clear();
        }
    }
}
