﻿using ET.EventType;
using ET.FUIBattle;
using UnityEngine;

namespace ET
{
    public class BattleEnd_RemoveComponent : AEvent<EventType.BattleEnd>
    {
        protected override void Run(BattleEnd args)
        {
            RunAsync(args).Coroutine();
        }

        private async ETTask RunAsync(BattleEnd args)
        {
            var zoneScene = args.Unit.ZoneScene();
            var fuiComp = zoneScene.GetComponent<FUIComponent>();
            var battleMain = fuiComp.GetUI(FUI_BattleMain.UIResName) as FUIBattleMainComponent;
            battleMain.ShowBattleResult(args.IsWin);
            
            await TimerComponent.Instance.WaitAsync(1000);
            await BattleHelper.ExitBattle(args.Unit);
            zoneScene.CurrentScene().RemoveComponent<BattleManagerComponent>();
        }
    }
}