/** This is an automatically generated class by FairyGUI. Please do not modify it. **/

using ET.EventType;
using FairyGUI;
namespace ET
{
    using FUIBattle;
    
    public class FUIBattleListWindowComponentAwakeSystem : AwakeSystem<FUIBattleListWindowComponent>
    {
        public override void Awake(FUIBattleListWindowComponent self)
        {
            self.Awake();
        }
    }
                
    [FriendClass(typeof(BattleManagerComponent))]
    [FriendClass(typeof(Fighter))]
    public static partial class FUIBattleListWindowComponentSystem
    {
        public static void Awake(this FUIBattleListWindowComponent self)
        {
            self.FUIBattleListWindow = self.Parent.GetComponent<FUI_BattleListWindow>();      
            self.Window = new Window();
            self.Window.contentPane = self.FUIBattleListWindow.FGComp;
            
            UIObjectFactory.SetPackageItemExtension(FUIPackage.Battle_ActionItem, typeof(ActionItem));
            self.FUIBattleListWindow.FGComp.fairyBatching = true;
            self.FUIBattleListWindow.m_ActionItemList.SetVirtual();
            self.FUIBattleListWindow.m_ActionItemList.itemRenderer = self.ActionItemRender;
            
            
            // events
            self.FUIBattleListWindow.m_CloseButton.FGComp.onClick.Set(self.OnCloseButtonClick);
            
            self.UpdateMsg();
        }

        public static void UpdateMsg(this FUIBattleListWindowComponent self)
        {
            var battleMgr = self.ZoneScene().CurrentScene().GetComponent<BattleManagerComponent>();
            
            var list = self.FUIBattleListWindow.m_ActionItemList;
            list.numItems = 0;
            self.ActionItemMsgs.Clear();

            int round = 1;
            foreach (TurnInfo roundInfo in battleMgr.TurnInfos)
            {
                string roundMsg = $"===第{round}次攻击===";
                self.ActionItemMsgs.Add(roundMsg);
                list.numItems++;
                foreach (AtkInfo atkInfo in roundInfo.AtkList)
                {
                    var attacker = battleMgr.BattleInfo.GetFighter(atkInfo.AtkId);
                    var target = battleMgr.BattleInfo.GetFighter(atkInfo.TargetId);
                    
                    string attackType = BattleViewHelper.GetAttackTypeMsg(atkInfo);
                    string msg = $"[u][({attacker.Pos}){attacker.Name}][/u] {attackType} [u][({target.Pos}){target.Name}][/u]";
                    
                    foreach (HurtInfo hurtInfo in atkInfo.HurtList)
                    {
                        var hurtTarget = battleMgr.BattleInfo.GetFighter(hurtInfo.TargetId);
                        msg += $" ,造成[u][({hurtTarget.Pos}){hurtTarget.Name}][/u][color=#FF0000]{hurtInfo.Damage}[/color]点伤害";
                        if (!hurtInfo.IsAlive)
                        {
                            msg += $",[u][({hurtTarget.Pos}){hurtTarget.Name}][/u][color=#FF0000]死亡[/color]";
                        }
                    }
                    
                    self.ActionItemMsgs.Add(msg);
                    // var actionItem = (ActionItem)list.AddItemFromPool();
                    // actionItem.SetContent(msg);
                    
                    list.numItems++;
                    list.ScrollToView(list.numItems - 1);
                }

                round++;
            }
        }

        public static void ActionItemRender(this FUIBattleListWindowComponent self, int index, GObject obj)
        {
            string msg = self.ActionItemMsgs[index];
            ((ActionItem)obj).SetContent(msg);
        }

        public static void OnCloseButtonClick(this FUIBattleListWindowComponent self)
        {
            self.Window.Hide();
        }
    }
}