/** This is an automatically generated class by FairyGUI. Please do not modify it. **/

using System.Collections.Generic;
using System.Linq;
using Animancer;
using FairyGUI;
using NCalc;
using UnityEngine;

namespace ET
{
    using FUIBattle;

    public class FUIBattleMainComponentAwakeSystem: AwakeSystem<FUIBattleMainComponent>
    {
        public override void Awake(FUIBattleMainComponent self)
        {
            self.Awake();
        }
    }
    
    [FriendClass(typeof(FUI))]
    [FriendClass(typeof(Fighter))]
    [FriendClass(typeof(Battle))]
    [FriendClass(typeof(Skill))]
    [FriendClass(typeof(FUI_BattleUnitInfo))]
    [FriendClass(typeof(FUI_HpBar))]
    [FriendClass(typeof(BattleUnitViewComponent))]
    public static partial class FUIBattleMainComponentSystem
    {
        public static void Awake(this FUIBattleMainComponent self)
        {
            self.FUIBattleMain = self.Parent.GetComponent<FUI_BattleMain>();
            self.FUIBattleMain.FGComp.fairyBatching = true;
            UIObjectFactory.SetPackageItemExtension(FUIPackage.Battle_BattleUnitItem, typeof (BattleUnitItem));
            UIObjectFactory.SetPackageItemExtension(FUIPackage.Battle_BuffItem, typeof (BuffItem));
            UIObjectFactory.SetPackageItemExtension(FUIPackage.Battle_BuffDescItem, typeof (BuffDescItem));
            UIObjectFactory.SetPackageItemExtension(FUIPackage.Battle_BagItem, typeof (BagItem));
            UIObjectFactory.SetPackageItemExtension(FUIPackage.Battle_SkillButton, typeof (SkillButton));

            GRoot.inst.HidePopup(self.FUIBattleMain.m_BuffDescList);
            GRoot.inst.HidePopup(self.FUIBattleMain.m_BagPanel.FGComp);
            // TODO: 上面的hidePopup无效，迷惑，先用Visible隐藏
            self.FUIBattleMain.m_BagPanel.Visible = false;

            // events
            // self.FUIBattleMain.GetParent<FUI>().OnHide = self.OnHide;
            self.FUIBattleMain.m_BagButton.FGComp.AddClickListenerAsync(self.OnBagButtonClick);
            self.FUIBattleMain.m_ReturnButton.FGComp.onClick.Add(self.OnReturnButtonClick);
            self.FUIBattleMain.m_BattleListButton.FGComp.onClick.Add(self.OnBattleListButtonClick);
        }

        public static void Init(this FUIBattleMainComponent self, Battle battle)
        {
            self.BattleInfo = battle;
            var list = self.FUIBattleMain.m_BattleUnitList;
            list.RemoveChildrenToPool();

            self.BattleUnitItemDict.Clear();
            foreach (var keyValuePair in battle.FighterDic)
            {
                var fighter = keyValuePair.Value;
                var item = (BattleUnitItem) list.AddItemFromPool();
                item.SetDead(false);
                item.SetName(fighter.Name);
                self.BattleUnitItemDict.Add(fighter.Id, item);

                var skillComp = fighter.GetComponent<SkillComponent>();
                var skills = skillComp.GetSkillList();
                if (skills.Count > 0)
                {
                    var skill = skills[0];
                    var skillInfo1 = new SkillInfo(fighter.Id, skill.ConfigId);
                    var skillConfig = SkillFatherConfigCategory.Instance.Get(skill.ConfigId);
                    // item.SkillButton1.SetIcon("ui://Battle/arrow");
                    item.SkillButton1.title = skillConfig.SkillName;
                    item.SkillButton1.SetFillAmount(0);
                    item.SkillButton1.data = skillInfo1;
                    item.SkillButton1.AddClickListenerAsync(self.OnSkillButtonClick);
                    var skillInfo2 = new SkillInfo(fighter.Id, skill.ConfigId);
                    item.SkillButton2.data = skillInfo2;
                    item.SkillButton2.AddClickListenerAsync(self.OnSkillButtonClick);
                }

                item.ManaProgressBar.value = 100;
                item.ManaProgressBar.value = fighter.GetFightSpirit();
            }

            // init for all battle unit
            var battleMgr = self.ZoneScene().CurrentScene().GetComponent<BattleManagerComponent>();
            foreach (var keyValuePair in battle.FighterDic)
            {
                var fighter = keyValuePair.Value;
                var fighterView = fighter.GetComponent<BattleUnitViewComponent>();
                var topPos = fighterView.GetTopPos();
                self.CreateUnitInfoUI(fighter, FUIHelper.ConvertToUIPos(topPos));
            }

            foreach (var keyValuePair in battle.EnemyDic)
            {
                var fighter = keyValuePair.Value;
                var fighterView = fighter.GetComponent<BattleUnitViewComponent>();
                var topPos = fighterView.GetTopPos();
                self.CreateUnitInfoUI(fighter, FUIHelper.ConvertToUIPos(topPos));
            }

            self.RefreshRoundNum();
            self.ResetUnitStateInfo();
            
            self.FUIBattleMain.m_BattleResultGroup.visible = false;
        }

        public static FUI_BattleUnitInfo CreateUnitInfoUI(this FUIBattleMainComponent self, Fighter fighter, Vector2 pos)
        {
            // TODO： 注意这里动态添加的UI元素，需要手动释放
            FUI_BattleUnitInfo infoEntity = FUIHelper.CreateInstance<FUI_BattleUnitInfo>(self.FUIBattleMain);

            self.FUIBattleMain.FGComp.AddChild(infoEntity.FGComp);
            infoEntity.FGComp.xy = pos;

            infoEntity.m_Pos.text = fighter.Pos.ToString();
            self.UpdateHpBar(infoEntity, fighter);
            self.UpdateBuffItem(infoEntity, fighter);

            self.BattleUnitInfos.Add(fighter.Id, infoEntity);
            return infoEntity;
        }

        public static void RemoveAllUnitInfoUI(this FUIBattleMainComponent self)
        {
            foreach (var fuiBattleUnitInfo in self.BattleUnitInfos)
            {
                self.FUIBattleMain.FGComp.RemoveChild(fuiBattleUnitInfo.Value.FGComp);
                fuiBattleUnitInfo.Value.FGComp.Dispose();
            }
            
            self.BattleUnitInfos.Clear();
        }

        public static void RemoveUnitInfoUIById(this FUIBattleMainComponent self, long id)
        {
            FUI_BattleUnitInfo infoEntity = self.BattleUnitInfos[id];
            if (infoEntity != null)
            {
                self.FUIBattleMain.FGComp.RemoveChild(infoEntity.FGComp);
                self.BattleUnitInfos.Remove(id);
            }
        }

        public static void UpdateUnitStateInfo(this FUIBattleMainComponent self, Fighter fighter, string msg)
        {
            var infoEntity = self.BattleUnitInfos[fighter.Id];
            if (infoEntity != null)
            {
                infoEntity.m_Tips.text = msg;
            }
        }

        public static void ResetUnitStateInfo(this FUIBattleMainComponent self)
        {
            foreach (var keyValuePair in self.BattleInfo.FighterDic)
            {
                var fighter = keyValuePair.Value;
                self.UpdateUnitStateInfo(fighter, "");
            }

            foreach (var keyValuePair in self.BattleInfo.EnemyDic)
            {
                var fighter = keyValuePair.Value;
                self.UpdateUnitStateInfo(fighter, "");
            }
        }

        public static void RefreshRoundNum(this FUIBattleMainComponent self)
        {
            self.FUIBattleMain.m_RoundNum.text = $"{self.BattleInfo.BattleRound}/99";
        }

        public static void RefreshUI(this FUIBattleMainComponent self)
        {
            // refresh round num
            self.RefreshRoundNum();

            self.ResetUnitStateInfo();
            
            

            // var list = self.FUIBattleMain.m_BattleUnitList;
            // list.RemoveChildrenToPool();

            // for (int i = 0; i < 5; i++)
            // {
            //     var item = (BattleUnitItem) list.GetChildAt(i);
            //     // 根据死亡更新界面
            // }
            
            foreach (var keyValuePair in self.BattleInfo.FighterDic)
            {
                self.RefreshFighterSkillCD(keyValuePair.Key);
            }
            // foreach (var keyValuePair in self.BattleInfo.EnemyDic)
            // {
            //     var fighter = keyValuePair.Value;
            //     var unitInfo = self.BattleUnitInfos[fighter.Id];
            //     if (unitInfo != null)
            //     {
            //         self.UpdateHpBar(unitInfo, fighter);
            //         self.UpdateBuffItem(unitInfo, fighter);
            //     }
            // }
        }

        public static void RefreshBattleUnitUI(this FUIBattleMainComponent self, long battleUnitId)
        {
            var fighter = self.BattleInfo.GetFighter(battleUnitId);
            if (self.BattleUnitInfos.ContainsKey(battleUnitId))
            {

                var unitInfo = self.BattleUnitInfos[battleUnitId];
                if (unitInfo != null)
                {
                    self.UpdateHpBar(unitInfo, fighter);
                    self.UpdateBuffItem(unitInfo, fighter);
                }
            }

            if (self.BattleUnitItemDict.ContainsKey(battleUnitId))
            {
                var item = self.BattleUnitItemDict[battleUnitId];
                if (!fighter.IsAlive)
                {
                    item.SetDead(true);
                    
                    self.RefreshFightSpirit(battleUnitId);
                }
            }
        }

        public static void RefreshFightSpirit(this FUIBattleMainComponent self, long battleUnitId)
        {
            if (self.BattleUnitItemDict.ContainsKey(battleUnitId))
            {
                var item = self.BattleUnitItemDict[battleUnitId];
                var fighter = self.BattleInfo.GetFighter(battleUnitId);
                item.ManaProgressBar.max = 100;
                item.ManaProgressBar.value = fighter.GetFightSpirit();
            }
        }

        public static void RefreshAllFightSpirit(this FUIBattleMainComponent self)
        {
            foreach ((long key, BattleUnitItem value) in self.BattleUnitItemDict)
            {
                self.RefreshFightSpirit(key);
            }
        }

        public static void UpdateHpBar(this FUIBattleMainComponent self, FUI_BattleUnitInfo infoEntity, Fighter fighter)
        {
            var HpMax = fighter.GetHpMax();
            var Hp = fighter.GetHp();

            infoEntity.m_HpBar.FGComp.max = HpMax;
            infoEntity.m_HpBar.FGComp.value = Hp;
        }

        public static void UpdateBuffItem(this FUIBattleMainComponent self, FUI_BattleUnitInfo infoEntity, Fighter fighter)
        {
            var list = infoEntity.m_BuffList;
            list.RemoveChildrenToPool();

            for (int i = 0; i < 4; i++)
            {
                var item = (BuffItem) list.AddItemFromPool();
                item.SetTitle(i.ToString());
            }
        }

        public static void RefreshFighterSkillCD(this FUIBattleMainComponent self, long battleUnitId)
        {
            if (!self.BattleUnitItemDict.TryGetValue(battleUnitId, out BattleUnitItem item))
            {
                return;
            }
       
            var fighter = self.BattleInfo.GetFighter(battleUnitId);
            var skillComp = fighter.GetComponent<SkillComponent>();
            var skills = skillComp.GetSkillList();
            var skill = skills[0];
            item.SkillButton1.SetFillAmount((float)skill.CoolTime / skill.Config.CDParameter);
        }

        public static async ETTask OnSkillButtonClick(this FUIBattleMainComponent self, EventContext context)
        {
            var sender = (SkillButton) context.sender;
            var skillInfo = (SkillInfo) sender.data;
            Log.Info($"{skillInfo.SkillUnitId} | {skillInfo.SkillId}");
            var unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            await BattleHelper.UseSkill(unit, skillInfo.SkillUnitId, skillInfo.SkillId);

            var fighter = self.BattleInfo.GetFighter(skillInfo.SkillUnitId);
            var skill = fighter.GetComponent<SkillComponent>().GetSkill(skillInfo.SkillId);
            sender.SetFillAmount((float)skill.CoolTime / skill.Config.CDParameter);
            self.RefreshFightSpirit(skillInfo.SkillUnitId);

            await ETTask.CompletedTask;
        }

        public static void ShowBuffDesc(this FUIBattleMainComponent self, Vector2 pos)
        {
            var list = self.FUIBattleMain.m_BuffDescList;

            list.RemoveChildrenToPool();
            for (int i = 0; i < 3; i++)
            {
                var item = (BuffDescItem) list.AddItemFromPool();
            }

            GRoot.inst.ShowPopup(self.FUIBattleMain.m_BuffDescList);
            list.xy = pos;
        }

        public static void UpdateRoundNum(this FUIBattleMainComponent self, int roundNum)
        {
            self.FUIBattleMain.m_RoundNum.text = roundNum + "/99";
        }

        public static async ETTask OnBagButtonClick(this FUIBattleMainComponent self)
        {
            self.FUIBattleMain.m_BagPanel.Visible = true;
            GRoot.inst.ShowPopup(self.FUIBattleMain.m_BagPanel.FGComp);
            
            // update bag item
            var list = self.FUIBattleMain.m_BagPanel.m_BagItemList;
            list.RemoveChildrenToPool();
            
            foreach (var keyValuePair in self.BattleInfo.DropDic)
            {
                var itemId = keyValuePair.Key;
                var itemNum = keyValuePair.Value;

                BagItem bagItem = (BagItem) list.AddItemFromPool();
                var itemConfig = AllItemConfigCategory.Instance.Get(itemId);
                bagItem.SetIcon($"ui://AllItem/{itemConfig.Icon}");
                bagItem.SetNum(itemNum);
            }
            await ETTask.CompletedTask;
        }

        public static void OnHide(this FUIBattleMainComponent self)
        {
            foreach (var fuiBattleUnitInfo in self.BattleUnitInfos)
            {
                if (fuiBattleUnitInfo.Value != null)
                {
                    // 暂时假定不
                    self.FUIBattleMain.FGComp.RemoveChild(fuiBattleUnitInfo.Value.FGComp, true);
                }
            }

            self.BattleUnitInfos.Clear();
        }

        public static void OnReturnButtonClick(this FUIBattleMainComponent self)
        {
            var battleMgr = self.ZoneScene().CurrentScene().GetComponent<BattleManagerComponent>();
            battleMgr.OnBattleEnd(false);
        }

        public static void OnBattleListButtonClick(this FUIBattleMainComponent self)
        {
            var fuiComp = self.ZoneScene().GetComponent<FUIComponent>();
            var battleListWindow = fuiComp.ShowWindow<FUI_BattleListWindow, FUIBattleListWindowComponent>(FUI_BattleListWindow.UIPackageName);
        }

        public static void ShowBattleResult(this FUIBattleMainComponent self, bool isWin)
        {
            self.RemoveAllUnitInfoUI();
            self.FUIBattleMain.m_BattleResultGroup.visible = true;
            self.FUIBattleMain.m_isWin.selectedIndex = isWin? 1 : 0;
        }

        public static void ShowDropItem(this FUIBattleMainComponent self, long battleUnitId, int itemId, int itemNum)
        {
            var battleMgr = self.ZoneScene().CurrentScene().GetComponent<BattleManagerComponent>();
            var fighterView = battleMgr.GetFighterViewComponent(battleUnitId);
            var pos = fighterView.DisplayGameObject.transform.position;
            Vector3 screenPos = Camera.main.WorldToScreenPoint(pos);
            screenPos.y = Screen.height - screenPos.y; //convert to Stage coordinates system

            Vector3 pt = GRoot.inst.GlobalToLocal(screenPos);
            var itemConfig = AllItemConfigCategory.Instance.Get(itemId);


            DropItemComponent dic;
            if (self.DropItemComponentPool.Count > 0)
            {
                dic = self.DropItemComponentPool.Pop();
            }
            else
            {
                dic = new DropItemComponent();
            }
            dic.OnFlyComplete = component =>
            {
                self.FUIBattleMain.FGComp.RemoveChild(component);
                self.ReturnDropItem(component);
            };
            self.FUIBattleMain.FGComp.AddChild(dic);
            dic.DropAndFly($"ui://AllItem/{itemConfig.Icon}", pt, self.FUIBattleMain.m_BagButton.FGComp.xy);
        }

        public static void ReturnDropItem(this FUIBattleMainComponent self, DropItemComponent comp)
        {
            self.DropItemComponentPool.Push(comp);
        }
    }
}