﻿using ET.EventType;

namespace ET
{
    using FUIBuilding;
    
    [FriendClass(typeof(FUIPrepareBuildingWindowComponent))]
    public class AfterRemoveConstruct_CloseWindow : AEvent<EventType.AfterRemoveConstruct>
    {
        protected override void Run(AfterRemoveConstruct args)
        {
            var unit = args.Unit;

            var fuiComponent = unit.ZoneScene().GetComponent<FUIComponent>();
            var prepareBuildingWindowComponent = (FUIPrepareBuildingWindowComponent)
                    fuiComponent.GetWindow(FUI_PrepareBuildingWindow.UIResName);

            if (prepareBuildingWindowComponent != null && 
                prepareBuildingWindowComponent.IsShowing && 
                prepareBuildingWindowComponent.Construct == args.Construct)
            {
                fuiComponent.HideWindow(FUI_PrepareBuildingWindow.UIResName);
            }
        }
    }
}