﻿using FairyGUI;
using UnityEngine;

namespace ET
{
    using FUIBuilding;
    using FUIMain;
    public class FUIBuildingEditComponentAwakeSystem : AwakeSystem<FUIBuildingEditComponent>
    {
        public override void Awake(FUIBuildingEditComponent self)
        {
            self.Awake();
        }
    }
    
    public static partial class FUIBuildingEditComponentSystem
    {
        public static void Awake(this FUIBuildingEditComponent self)
        {
            self.FUIBuildingEdit = self.Parent.GetComponent<FUI_BuildingEdit>();
            Window win = new Window();
            win.contentPane = self.FUIBuildingEdit.FGComp;
            self.Window = win;
            
            self.FUIBuildingEdit.m_confirm.FGComp.onClick.Add(self.OnConfirmButtonClicked);
            self.FUIBuildingEdit.m_cancel.FGComp.onClick.Add(self.OnCancelButtonClicked);
        }
        
        public static void OnConfirmButtonClicked(this FUIBuildingEditComponent self)
        {
			self.OnCreateBuildingConfirm?.Invoke();
        }

        
        public static void OnCancelButtonClicked(this FUIBuildingEditComponent self)
        {
            self.OnCreateBuildingCancle?.Invoke();
        }

        public static void SetConfirmButtonPos(this FUIBuildingEditComponent self, Vector2 pos)
        {
            pos.y = Screen.height - pos.y;
            self.FUIBuildingEdit.m_confirm.FGComp.xy = GRoot.inst.GlobalToLocal(pos);
        }
        
        public static void SetCancelButtonPos(this FUIBuildingEditComponent self, Vector2 pos)
        {
            pos.y = Screen.height - pos.y;
            self.FUIBuildingEdit.m_cancel.FGComp.xy = GRoot.inst.GlobalToLocal(pos);
        }
    }
}