/** This is an automatically generated class by FairyGUI. Please do not modify it. **/

using System.Collections.Generic;
using System.Linq;
using FairyGUI;
namespace ET
{
    using FUIPeople;
    
    public class FUILineupWindowComponentAwakeSystem : AwakeSystem<FUILineupWindowComponent>
    {
        public override void Awake(FUILineupWindowComponent self)
        {
            self.Awake();
        }
    }
                
    [FriendClass(typeof(FUILineupWindowComponent))]
    [FriendClass(typeof(FUI_LineupWindow))]
    [FriendClass(typeof(People))]
    [FriendClass(typeof(Unit))]
    public static partial class FUILineupWindowComponentSystem
    {
        public static void Awake(this FUILineupWindowComponent self)
        {
            self.FUILineupWindow = self.Parent.GetComponent<FUI_LineupWindow>();
            var win = new FUILineupWindow();
            win.OnWindowShow = self.OnWindowShow;
            self.Window = win;
            self.Window.contentPane = self.FUILineupWindow.FGComp;
            
            UIObjectFactory.SetPackageItemExtension(FUIPackage.People_LineupPeopleItem, typeof(LineupPeopleItem));
            // events
            self.FUILineupWindow.m_PeopleList.onClickItem.Add(self.OnPartnerItemClick);
            
            self.InitLineupSeat();
        }

        public static void OnWindowShow(this FUILineupWindowComponent self)
        {
            self.ShowInfo();
        }

        public static void ShowInfo(this FUILineupWindowComponent self)
        {
            self.RefreshPickPeopleList();
            self.RefreshLineupSeat();
        }

        private static void InitLineupSeat(this FUILineupWindowComponent self)
        {
            var list = self.FUILineupWindow.m_LineupSeatList;
            self.LineupSeatItems.Add(1, list.GetChildAt(6) as LineupSeatItem);
            self.LineupSeatItems.Add(2, list.GetChildAt(7) as LineupSeatItem);
            self.LineupSeatItems.Add(3, list.GetChildAt(8) as LineupSeatItem);
            self.LineupSeatItems.Add(4, list.GetChildAt(3) as LineupSeatItem);
            self.LineupSeatItems.Add(5, list.GetChildAt(4) as LineupSeatItem);
            self.LineupSeatItems.Add(6, list.GetChildAt(5) as LineupSeatItem);
            self.LineupSeatItems.Add(7, list.GetChildAt(0) as LineupSeatItem);
            self.LineupSeatItems.Add(8, list.GetChildAt(1) as LineupSeatItem);
            self.LineupSeatItems.Add(9, list.GetChildAt(2) as LineupSeatItem);
            
            foreach (var itemPair in self.LineupSeatItems)
            {
                var item = itemPair.Value;
                item.onDrop.Add(self.OnDropPickPeopleItem);
                item.CancelButton.data = item;
                item.CancelButton.onClick.Add(self.OnClearPeopleInSeat);

                GLoader icon = item.GetIcon();
                icon.data = item;
                icon.draggable = true;
                icon.onDragStart.Add(self.OnDragSeatItem);
            }
        }

        private static void SetPeopleToLinupSeat(this FUILineupWindowComponent self, People people, LineupSeatItem item)
        {
            if (people == null)
            {
                item.ClearPeople();
            }
            else
            {
                item.SetPeople(people.Id);
                item.SetName(people.Name);
                item.SetIcon(PeopleViewHelper.GetHeadIconUrlByGender(people.GetGender()));       
            }
        }

        private static void RefreshPickPeopleList(this FUILineupWindowComponent self)
        {
            // show people list
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var peopleComp = unit.GetComponent<PeopleComponent>();

            Dictionary<long, int> fightSeatMap = new Dictionary<long, int>();
            foreach (var keyValuePair in unit.FighterDic)
            {
                fightSeatMap.Add(keyValuePair.Value, keyValuePair.Key);
            }

            var list = self.FUILineupWindow.m_PeopleList;
            list.RemoveChildrenToPool();

            int index = 0;
            foreach (var v in peopleComp.Children)
            {
                People people = (People)v.Value;
                if (people.Config.Type == (int)RoleType.NormalPeople)
                {
                    continue;
                }
                LineupPeopleItem item = (LineupPeopleItem) list.AddItemFromPool();

                item.data = people.Id;
                GLoader icon = item.GetIcon();
                icon.data = item;
                icon.draggable = true;
                icon.onDragStart.Remove(self.OnDragPickPeopleItem);
                icon.onDragStart.Add(self.OnDragPickPeopleItem);
                item.SetName(people.Name);
                item.SetIcon(PeopleViewHelper.GetHeadIconUrlByGender(people.GetGender()));
                var numeric = people.GetComponent<NumericComponent>();
                item.SetFightPoint(people.Labor);

                if (fightSeatMap.ContainsKey(people.Id))
                {
                    item.SetLineupSeat(fightSeatMap[people.Id]);
                }
                else
                {
                    item.SetLineupSeat(0);
                }

                if (self.CurSelectPeopleId == 0)
                {
                    self.CurSelectPeopleId = people.Id;
                }
                
                if (people.Id == self.CurSelectPeopleId)
                {
                    list.selectedIndex = index;
                    self.SelectPartner(people.Id);
                }
                
                index++;
            }
        }

        private static void RefreshLineupSeat(this FUILineupWindowComponent self)
        {
            // clear
            foreach (var pair in self.LineupSeatItems)
            {
                self.SetPeopleToLinupSeat(null, pair.Value);
            }
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var peopleComp = unit.GetComponent<PeopleComponent>();
            foreach (var keyValuePair in unit.FighterDic)
            {
                if (self.LineupSeatItems.ContainsKey(keyValuePair.Key))
                {
                    var people = peopleComp.GetChild<People>(keyValuePair.Value);
                    self.SetPeopleToLinupSeat(people, self.LineupSeatItems[keyValuePair.Key]);
                }
            }
        }

        private static async ETTask ApplyLineupSeat(this FUILineupWindowComponent self)
        {
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            Dictionary<int, long> newLineup = new Dictionary<int, long>();

            foreach (var pair in self.LineupSeatItems)
            {
                var item = pair.Value;
                if (item.HasPeople())
                {
                    newLineup.Add(pair.Key, item.GetPeopleId());
                }
            }

            await BattleHelper.Embattle(unit, newLineup);
            self.RefreshPickPeopleList();
        }

        private static void OnDragPickPeopleItem(this FUILineupWindowComponent self, EventContext eventContext)
        {
            GObject obj = (GObject)eventContext.sender;
            LineupPeopleItem item = (LineupPeopleItem)obj.data;
            eventContext.PreventDefault();
            DragDropManager.inst.StartDrag(item, item.GetIconUrl(), item.data, (int)eventContext.data);
        }

        private static void OnDragSeatItem(this FUILineupWindowComponent self, EventContext eventContext)
        {
            GLoader obj = (GLoader)eventContext.sender;
            LineupSeatItem item = (LineupSeatItem) obj.data;
            eventContext.PreventDefault();
            DragDropManager.inst.StartDrag(item, obj.url, item.GetPeopleId(), (int)eventContext.data);
            item.ClearPeople();
        }

        private static void OnDropPickPeopleItem(this FUILineupWindowComponent self, EventContext eventContext)
        {
            LineupSeatItem item = (LineupSeatItem) eventContext.sender;
            long peopleId = (long) eventContext.data;
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var peopleComp = unit.GetComponent<PeopleComponent>();
            var people = peopleComp.GetChild<People>(peopleId);
            
            
            // 去重
            foreach (var pair in self.LineupSeatItems)
            {
                if (pair.Value.GetPeopleId() == peopleId)
                {
                    pair.Value.ClearPeople();
                }
            }
            
            self.SetPeopleToLinupSeat(people, item);
            self.ApplyLineupSeat().Coroutine();
        }

        private static void OnClearPeopleInSeat(this FUILineupWindowComponent self, EventContext eventContext)
        {
            var obj = eventContext.sender as GObject;
            LineupSeatItem item = (LineupSeatItem) obj.data;
            item.ClearPeople();
        }

        private static void SelectPartner(this FUILineupWindowComponent self, long peopleId)
        {
            self.CurSelectPeopleId = peopleId;
        }
        
        private static void OnPartnerItemClick(this FUILineupWindowComponent self, EventContext context)
        {
            var obj = context.data as GObject;
            long peopleId = (long) obj.data;

            self.SelectPartner(peopleId);
        }
    } 
                
}