/** This is an automatically generated class by FairyGUI. Please do not modify it. **/

using FairyGUI;
using UnityEngine;

namespace ET
{
    using FUIPeople;
    
    public class FUIPartnerInfoWindowComponentAwakeSystem : AwakeSystem<FUIPartnerInfoWindowComponent>
    {
        public override void Awake(FUIPartnerInfoWindowComponent self)
        {
            self.Awake();
        }
    }

    internal static class SkillPanelType
    {
        public const int Info = 0;
        public const int Skill = 1;
        public const int MindAbility = 2;
    }
                
    [FriendClass(typeof(People))]
    public static partial class FUIPartnerInfoWindowComponentSystem
    {
        public static void Awake(this FUIPartnerInfoWindowComponent self)
        {
            self.FUIPartnerInfoWindow = self.Parent.GetComponent<FUI_PartnerInfoWindow>();
            var win = new FUIPartnerInfoWindow();
            win.OnWindowShow = self.OnWindowShow;
            win.OnWindowHide = self.OnWindowHide;
            self.Window = win;
            self.Window.contentPane = self.FUIPartnerInfoWindow.FGComp;
            
            self.ZoneScene().GetComponent<FUIPackageComponent>().AddPackage(FUIPackage.SkillIcon);
            UIObjectFactory.SetPackageItemExtension(FUIPackage.People_SkillGroupItem, typeof(SkillGroupItem));
            UIObjectFactory.SetPackageItemExtension(FUIPackage.People_PassiveEffectItem, typeof(PassiveEffectItem));
            
            // init events
            self.FUIPartnerInfoWindow.m_tab.onChanged.Add(self.OnTabChanged);

        }
        
        public static void OnWindowShow(this FUIPartnerInfoWindowComponent self)
        {
            //self.ShowInfo();
        }
        
        public static void OnWindowHide(this FUIPartnerInfoWindowComponent self)
        {
            var fuiComponent = self.ZoneScene().GetComponent<FUIComponent>();
            FUIPartnerListWindowComponent peopleListWin = fuiComponent.GetWindow(FUI_PartnerListWindow.UIResName) as FUIPartnerListWindowComponent;
            peopleListWin.RefreshSkeleton();
        }
        
        public static void ShowPartnerInfo(this FUIPartnerInfoWindowComponent self, long id)
        {
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            
           
            People people = unit.GetComponent<PeopleComponent>().GetChild<People>(id);
            self.CurShowPeople = people;
            self.FUIPartnerInfoWindow.m_Name.text = people.Name;

            // show avatar
            GameObject avatarGO = PeopleSkeletonCache.GetSkeletonGO(id);

            avatarGO.transform.localScale = new Vector3(20, 20, 20);

            if (self.AvatarWrapper == null)
            {
                self.AvatarWrapper = new GoWrapper(avatarGO); 
                GGraph avatarHolder = self.FUIPartnerInfoWindow.m_Avatar.asGraph;
                avatarHolder.SetNativeObject(self.AvatarWrapper);
            }
            else
            {
                self.AvatarWrapper.wrapTarget.SetActive(false);
                self.AvatarWrapper.wrapTarget = avatarGO;
                avatarGO.SetActive(true);
            }
            
            self.OnTabChanged();
        }

        public static void OnTabChanged(this FUIPartnerInfoWindowComponent self)
        {
            var index = self.FUIPartnerInfoWindow.m_tab.selectedIndex;
            switch (index)
            {
                case SkillPanelType.Info:
                {
                    var people = self.CurShowPeople;
                    int curLevelupNeedExp = UpExpConfigCategory.Instance.Get(people.Level).Exp;

                    // exp
                    self.FUIPartnerInfoWindow.m_XpBar.FGComp.max = curLevelupNeedExp;
                    self.FUIPartnerInfoWindow.m_XpBar.FGComp.value = people.Exp;
                    
                    // hp
                    self.FUIPartnerInfoWindow.m_HpBar.FGComp.max = people.GetHp();
                    self.FUIPartnerInfoWindow.m_HpBar.FGComp.value = people.GetHp();
                    
                    // property
                    self.FUIPartnerInfoWindow.m_LevelText.text = people.Level.ToString();
                    
                }
                    break;
                case SkillPanelType.Skill:
                {
                    var list = self.FUIPartnerInfoWindow.m_SkillGroupList;
                    list.RemoveChildrenToPool();
                    
                    for (int i = 0; i < 4; i++)
                    {
                        int skillId = 101;
                        var item = (SkillGroupItem) list.AddItemFromPool();
                        item.SetIcon($"ui://{FUIPackage.SkillIcon}/arrow");
                        item.SetName("技能" + i);
                        item.data = skillId;
                        item.onClick.Remove(self.OnSkillGroupItemClick);
                        item.onClick.Add(self.OnSkillGroupItemClick);

                        if (self.CurSelectedSkillGroupId == 0)
                        {
                            // 默认选中第一个
                            self.CurSelectedSkillGroupId = skillId;
                        }

                        if (skillId == self.CurSelectedSkillGroupId)
                        {
                            list.AddSelection(i, true);
                            self.SelectGroupItem(skillId);
                        }
                    }
                }
                    break;
            }
        }

        public static void OnSkillGroupItemClick(this FUIPartnerInfoWindowComponent self, EventContext eventContext)
        {
            GObject sender = eventContext.sender as GObject;
            int skillGroupId = (int)sender.data;

            self.SelectGroupItem(skillGroupId);
        }

        public static void SelectGroupItem(this FUIPartnerInfoWindowComponent self, int skillGroupId)
        {
            var list = self.FUIPartnerInfoWindow.m_SkillPassiveEffectList;
            list.RemoveChildrenToPool();
            var skillFatherConfig = SkillFatherConfigCategory.Instance.Get(skillGroupId);
            var unLockedSkills = SkillUpConfigCategory.Instance.GetUnLockedSkillsOfLevel(skillFatherConfig.SkillUp, 10);
            if (unLockedSkills != null)
            {
                for (int i = 0; i < unLockedSkills.Length; i++)
                {
                    var skillId = unLockedSkills[i];
                    var item = (PassiveEffectItem) list.AddItemFromPool();
                    item.SetIcon($"ui://{FUIPackage.SkillIcon}/arrow");
                    item.data = skillId;
                    item.onClick.Remove(self.OnPassiveItemClick);
                    item.onClick.Add(self.OnPassiveItemClick);

                    if (self.CurSelectedSkillId == 0)
                    {
                        // 默认选中第一个
                        self.CurSelectedSkillId = skillId;
                    }

                    if (self.CurSelectedSkillId == skillId)
                    {
                        list.AddSelection(i, true);
                        self.SelectPassiveItem(skillId);
                    }
                }
            }
        }

        public static void OnPassiveItemClick(this FUIPartnerInfoWindowComponent self, EventContext eventContext)
        {
            GObject sender = eventContext.sender as GObject;
            int skillId = (int)sender.data;
            self.SelectPassiveItem(skillId);
        }

        public static void SelectPassiveItem(this FUIPartnerInfoWindowComponent self, int skillId)
        {
            if (skillId <= 0)
            {
                self.FUIPartnerInfoWindow.m_SkillPassiveDesc.text = "";
                return;
            }
            
            var skillSonConfig = SkillSonConfigCategory.Instance.Get(skillId);

            self.FUIPartnerInfoWindow.m_SkillPassiveDesc.text = skillSonConfig.Describe;
        }
    } 
                
}