/** This is an automatically generated class by FairyGUI. Please do not modify it. **/

using FairyGUI;
using UnityEngine;

namespace ET
{
    using FUIPeople;
    public class FUIPeopleListWindowComponentAwakeSystem : AwakeSystem<FUIPeopleListWindowComponent>
    {
        public override void Awake(FUIPeopleListWindowComponent self)
        {
            self.Awake();
        }
    }
                
    [FriendClass(typeof(People))]
    public static partial class FUIPeopleListWindowComponentSystem
    {
        public static void Awake(this FUIPeopleListWindowComponent self)
        {
            self.FUIPeopleListWindow = self.Parent.GetComponent<FUI_PeopleListWindow>();
            FUIPeopleListWindow win = new FUIPeopleListWindow();
            win.OnWindowShow = self.OnWindowShow;


            self.Window = win;
            self.Window.contentPane = self.FUIPeopleListWindow.FGComp;
            
            UIObjectFactory.SetPackageItemExtension(FUIPackage.People_PeopleItem, typeof(PeopleItem));
        }

        public static void OnWindowShow(this FUIPeopleListWindowComponent self)
        {
            self.ShowInfo();
        }

        public static void RefreshSkeleton(this FUIPeopleListWindowComponent self)
        {
            var list = self.FUIPeopleListWindow.m_PeopleList;
            var count = list.numChildren;

            for (int i = 0; i < count; i++)
            {
                PeopleItem item = list.GetChildAt(i) as PeopleItem;
                GameObject go = PeopleSkeletonCache.GetSkeletonGO((long)item.data);
                go.transform.localScale = new Vector3(20, 20, 20);
                item.SetAvatar(go);
            }
        }
        
        public static void ShowInfo(this FUIPeopleListWindowComponent self)
        {
            // show people list
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var peopleComp = unit.GetComponent<PeopleComponent>();

            var list = self.FUIPeopleListWindow.m_PeopleList;
            
            list.RemoveChildrenToPool();
            foreach (var v in peopleComp.Children)
            {
           
                People people = (People)v.Value;
                PeopleItem item = (PeopleItem) list.AddItemFromPool();
                item.SetName(people.Name);
                item.data = people.Id;
                item.onClick.Remove(self.OnPeopleItemClick);
                item.onClick.Add(self.OnPeopleItemClick);
                GameObject go = PeopleSkeletonCache.GetSkeletonGO(people.Id);
                go.transform.localScale = new Vector3(20, 20, 20);
                item.SetAvatar(go);
                
                var numeric = people.GetComponent<NumericComponent>();
                int age = numeric.GetAsInt(NumericType.Age);
                item.SetAge(age);
                item.SetStrength(people.Labor);
            }

            self.FUIPeopleListWindow.m_PeopleNum.text = peopleComp.Children.Count.ToString();
        }
        
        private static void OnPeopleItemClick(this FUIPeopleListWindowComponent self, EventContext context)
        {
            var obj = context.sender as GObject;
            long peopleId = (long) obj.data;
            var fuiComponent = self.ZoneScene().GetComponent<FUIComponent>();
            var peopleInfoWin = fuiComponent.ShowWindow<FUI_PeopleInfoWindow, FUIPeopleInfoWindowComponent>();
            peopleInfoWin.ShowPeopleInfo(peopleId);
        }
    } 
                
}