/** This is an automatically generated class by FairyGUI. Please do not modify it. **/

using System.Linq;
using FairyGUI;
namespace ET
{
    using FUIPeople;
    
    public class FUISkillTestWindowComponentAwakeSystem : AwakeSystem<FUISkillTestWindowComponent>
    {
        public override void Awake(FUISkillTestWindowComponent self)
        {
            self.Awake();
        }
    }

    [FriendClass(typeof(People))]
    [FriendClass(typeof(Skill))]
    public static partial class FUISkillTestWindowComponentSystem
    {
        public static void Awake(this FUISkillTestWindowComponent self)
        {
            self.FUISkillTestWindow = self.Parent.GetComponent<FUI_SkillTestWindow>();      
            self.Window = new Window();
            self.Window.contentPane = self.FUISkillTestWindow.FGComp;
            
            // set item
            UIObjectFactory.SetPackageItemExtension(FUIPackage.People_TestSkilltem, typeof(TestSkillItem));
            UIObjectFactory.SetPackageItemExtension(FUIPackage.People_TestPartnerltem, typeof(TestPartnerItem));
            UIObjectFactory.SetPackageItemExtension(FUIPackage.People_TestPartnerSkilltem, typeof(TestPartnerSkillItem));
            
            // events
            self.FUISkillTestWindow.m_PartnerList.onClickItem.Add(self.OnPartnerItemClick);
            self.FUISkillTestWindow.m_AllSkillList.onClickItem.Add(self.OnAllSkillItemClick);
            self.FUISkillTestWindow.m_ReplaceButton.FGComp.onClick.Add(self.OnReplaceButtonClick);
        }

        public static void ShowInfo(this FUISkillTestWindowComponent self)
        {
            self.RefreshPartnerSkill();
            
            self.InitAllSkill();
        }

        private static void InitAllSkill(this FUISkillTestWindowComponent self)
        {
            var list = self.FUISkillTestWindow.m_AllSkillList;

            var configs = SkillFatherConfigCategory.Instance.GetAll();

            int index = 0;
            foreach (var skillFatherConfig in configs)
            {
                var skillId = skillFatherConfig.Key;
                var config = skillFatherConfig.Value;
                TestSkillItem item = (TestSkillItem) list.AddItemFromPool();
                item.data = skillId;
                item.SetName(config.SkillName);
                item.SetSkillId(skillId);

                if (self.CurSelectReplaceSkillId == 0)
                {
                    self.CurSelectReplaceSkillId = skillId;
                }

                if (self.CurSelectReplaceSkillId == skillId)
                {
                    list.selectedIndex = index;
                    self.SelectReplaceSkill(skillId);
                }
                
                index++;
            }
        }

        private static void RefreshPartnerSkill(this FUISkillTestWindowComponent self)
        {
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var peopleComp = unit.GetComponent<PeopleComponent>();

            var list = self.FUISkillTestWindow.m_PartnerList;
            
            list.RemoveChildrenToPool();

            int index = 0;
            foreach (var v in peopleComp.Children)
            {
                People people = (People)v.Value;
                if (people.Config.Type == (int)RoleType.NormalPeople)
                {
                    continue;
                }
                TestPartnerItem item = (TestPartnerItem) list.AddItemFromPool();
                item.SetName(people.Name);
                item.data = people.Id;

                var numeric = people.GetComponent<NumericComponent>();
                int age = numeric.GetAsInt(NumericType.Age);
                int lv = numeric.GetAsInt(NumericType.Lv);
                item.SetLevel(lv);

                if (self.CurSelectPeopleId == 0)
                {
                    self.CurSelectPeopleId = people.Id;
                }
                
                if (people.Id == self.CurSelectPeopleId)
                {
                    list.selectedIndex = index;
                    self.SelectPartner(people.Id);
                }
                
                index++;
            }
        }

        private static void SelectPartner(this FUISkillTestWindowComponent self, long peopleId)
        {
            self.CurSelectPeopleId = peopleId;
            var list = self.FUISkillTestWindow.m_SkillList;
            list.RemoveChildrenToPool();
            
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var peopleComp = unit.GetComponent<PeopleComponent>();
            var fighter = peopleComp.GetChild<People>(peopleId);
            if (fighter.Config.Type == ConstPeopleType.PEOPLE_FARMER)
            {
                Log.Error("Wrong people type");
                return;
            }

            var skillComp = fighter.GetComponent<SkillComponent>();
            var skills = skillComp.GetSkillList();
            for (int i = 0; i < skills.Count; i++)
            {
                var skill = skills[i];
                int skillId = skill.ConfigId;
                var item = (TestPartnerSkillItem) list.AddItemFromPool();
                var skillConfig = SkillFatherConfigCategory.Instance.Get(skillId);
                item.data = skillId;
                item.SetName(skillConfig.SkillName);
                item.SetSkillId(skillId);
                item.onClick.Remove(self.OnPartnerSkillItemClick);
                item.onClick.Add(self.OnPartnerSkillItemClick);

                if (self.CurSelectPartnerSkillId == -1)
                {
                    self.CurSelectPartnerSkillId = skillId;
                }

                if (self.CurSelectPartnerSkillId == skillId)
                {
                    list.selectedIndex = i;
                    self.SelectPartnerSkill(skillId);
                }
            }

        }
        
        private static void OnPartnerItemClick(this FUISkillTestWindowComponent self, EventContext context)
        {
            var obj = context.data as GObject;
            long peopleId = (long) obj.data;

            self.SelectPartner(peopleId);
        }

        private static void SelectPartnerSkill(this FUISkillTestWindowComponent self, int skillId)
        {
            self.CurSelectPartnerSkillId = skillId;
            Log.Info(skillId.ToString());
        }

        private static void OnPartnerSkillItemClick(this FUISkillTestWindowComponent self, EventContext context)
        {
            var obj = context.sender as GObject;
            int skillId = (int) obj.data;
            self.SelectPartnerSkill(skillId);
        }

        private static void SelectReplaceSkill(this FUISkillTestWindowComponent self, int skillId)
        {
            self.CurSelectReplaceSkillId = skillId;

            var config = SkillFatherConfigCategory.Instance.Get(skillId);

            self.FUISkillTestWindow.m_SkillDesc.text = config.Describe;
        }
        
        private static void OnAllSkillItemClick(this FUISkillTestWindowComponent self, EventContext context)
        {
            var obj = context.data as GObject;
            int skillId = (int) obj.data;
            
            self.SelectReplaceSkill(skillId);
        }


        private static void OnReplaceButtonClick(this FUISkillTestWindowComponent self)
        {
            Log.Info($"[{self.CurSelectPeopleId}][{self.CurSelectPartnerSkillId}] --> ({self.CurSelectReplaceSkillId})");
            
            self.ReplaceSkill(self.CurSelectPeopleId, self.CurSelectPartnerSkillId, self.CurSelectReplaceSkillId).Coroutine();
        }

        private static async ETTask<int> ReplaceSkill(this FUISkillTestWindowComponent self, long peopleId, int oldSkillId, int newSkillId)
        {
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            int result = await BattleHelper.TestReplaceSkill(unit, peopleId, oldSkillId, newSkillId);

            if (result == ErrorCode.ERR_Success)
            {
                self.RefreshPartnerSkill();
            }

            return result;
        }
    }
}