/** This is an automatically generated class by FairyGUI. Please do not modify it. **/

using System;
using System.Collections.Generic;
using ET.Demo.ResourceView;
using FairyGUI;
using UnityEngine;

namespace ET
{
    using FUIResource;
    
    [Timer(TimerType.UpdateGatherProgressTimer)]
    public class UpdateGatherProgressUITimer : ATimer<FUIResourceWindowComponent>
    {
        public override void Run(FUIResourceWindowComponent self)
        {
            try
            {
                if (self.IsDisposed || self.Parent == null)
                {
                    return;
                }

                if (self.DomainScene() == null)
                {
                    return;
                }
                
                self.UpdateProgress();
            }
            catch (Exception e)
            {
                Log.Error(e.ToString());
            }
        }
    }
    
    public class FUIResourceWindowComponentAwakeSystem : AwakeSystem<FUIResourceWindowComponent>
    {
        public override void Awake(FUIResourceWindowComponent self)
        {
            self.Awake();
        }
    }
                
    [FriendClass(typeof(Gather))]
    [FriendClass(typeof(People))]
    [FriendClass(typeof(ResourcePoint))]
    public static partial class FUIResourceWindowComponentSystem
    {
        public static void Awake(this FUIResourceWindowComponent self)
        {
            self.FUIResourceWindow = self.Parent.GetComponent<FUI_ResourceWindow>();
            UIObjectFactory.SetPackageItemExtension(FUIPackage.Resource_ProduceItem, typeof(ProduceItem));
            
            UIObjectFactory.SetPackageItemExtension(FUIPackage.Resource_TabButtonItem, typeof(TabButtonItem));
            var win = new FUIResourceWindow();
            win.OnWindowShow = self.OnWindowShow;
            win.OnWindowHide = self.OnWindowHide;
            self.Window = win;
            self.Window.contentPane = self.FUIResourceWindow.FGComp;
            
            self.FUIResourceWindow.m_AddPeopleButton.FGComp.onClick.Add(self.OnAddPeopleButtonClick);
            self.FUIResourceWindow.m_DetialButton.FGComp.onClick.Add(self.OnDetailButtonClick);
            self.FUIResourceWindow.m_CancelWorkerButton.FGComp.AddClickListenerAsync(self.OnCancelWorkerButtonClick);
            self.FUIResourceWindow.m_RemoveButton.FGComp.AddClickListenerAsync(self.OnRemoveButtonClick);
        }

        public static void OnWindowShow(this FUIResourceWindowComponent self)
        {
            // 加载所有Item资源
            self.ZoneScene().GetComponent<FUIPackageComponent>().AddPackage(FUIPackage.AllItem);
            

        }

        public static void OnWindowHide(this FUIResourceWindowComponent self)
        {
            TimerComponent.Instance.Remove(ref self.UpdateTimer);
            self.CurSelectResId = 0;
        }

        public static void ShowInfo(this FUIResourceWindowComponent self, ResourcePoint resourceInfo)
        {
            self.ResourcePoint = resourceInfo;
            var resourcePointConfig = resourceInfo.Config;
            
            string iconUrl = $"{resourcePointConfig.ResourcePicture[0]}";
            self.FUIResourceWindow.m_Icon.url = iconUrl;

            var tabList = self.FUIResourceWindow.m_TabButtonList;
            tabList.RemoveChildrenToPool();
            int idx = 0;
            foreach ((int key, ResourceAttri value) in self.ResourcePoint.ResAttriDic)
            {
                var resId = key;
                var config = ResourcesConfigCategory.Instance.Get(resId);
                var tabButton = (TabButtonItem) tabList.AddItemFromPool();
                tabButton.title.text = config.BehaviourName;
                tabButton.data = key;
                tabButton.onClick.Remove(self.OnActionTabButtonClick);
                tabButton.onClick.Add(self.OnActionTabButtonClick);
                
                self.FUIResourceWindow.m_ResourceActionTab.AddPage(idx.ToString());
                tabButton.relatedController = self.FUIResourceWindow.m_ResourceActionTab;
                tabButton.relatedPageId = self.FUIResourceWindow.m_ResourceActionTab.GetPageId(idx);

                if (self.CurSelectResId == 0)
                {
                    self.CurSelectResId = key;
                }

                if (self.CurSelectResId == key)
                {
                    tabList.AddSelection(idx, true);
                    self.SelectResource(self.CurSelectResId);
                }
                
                idx++;
            }

            TimerComponent.Instance.Remove(ref self.UpdateTimer);
            self.UpdateTimer = TimerComponent.Instance.NewRepeatedTimer(1000, TimerType.UpdateGatherProgressTimer, self);
        }

        private static void OnActionTabButtonClick(this FUIResourceWindowComponent self, EventContext eventContext)
        {
            var sender = (GObject)eventContext.sender;
            int resId = (int) sender.data;

            self.SelectResource(resId);
        }

        private static void SelectResource(this FUIResourceWindowComponent self, int resId)
        {
            if (self.ResourcePoint.ResAttriDic.TryGetValue(resId, out ResourceAttri info))
            {
                self.CurSelectResId = resId;
                var resourceConfig = ResourcesConfigCategory.Instance.Get(resId);
            
                // 检查是否有人在采集
                self.CurWorkPeople = null;
                var unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
                var gatherComp = unit.GetComponent<GatherComponent>();
                var gather = gatherComp?.GetherByResPointId(self.ResourcePoint.Id);
                if (gather!= null && gather.PeopleIdList.Count > 0)
                {
                    long peopleId = gather.PeopleIdList[0];
                    var peopleComp = unit.GetComponent<PeopleComponent>();
                    var people = peopleComp.GetChild<People>(peopleId);
                    self.SetCurWorker(people);
                }
                else
                {
                    self.FUIResourceWindow.m_hasPeople.selectedIndex = 0;
                }
                
                var baseOut = resourceConfig.BaseOut;
                var list = self.FUIResourceWindow.m_ProduceList;
                list.RemoveChildrenToPool();

                // 基礎產出
                if (baseOut > 0)
                {
                    var itemConfig = AllItemConfigCategory.Instance.Get(baseOut);
                    ProduceItem item = (ProduceItem) list.AddItemFromPool();
                    item.SetIcon($"ui://AllItem/{itemConfig.Icon}");
                    item.SetDropRate(0);
                    item.SetDropNum(resourceConfig.OutAmount);
                }

                // 額外產出
                if (resourceConfig.ExtraOut.Length > 0)
                {
                    for (int i = 0; i < resourceConfig.ExtraOut.Length; i++)
                    {
                        var extraOut = resourceConfig.ExtraOut[i];
                        if (extraOut == 0)
                        {
                            continue;
                        }
                        
                        var extraOutputConfig = ExtraOutputConfigCategory.Instance.Get(extraOut);
                        // var dropConfig = DropGroupConfigCategory.Instance.Get(extraOutputConfig.ItemId);

                        var itemId = extraOutputConfig.ItemId;
                        var itemData = AllItemConfigCategory.Instance.Get(itemId);
        
                        var item = (ProduceItem) list.AddItemFromPool();
                        item.SetIcon($"ui://AllItem/{itemData.Icon}");
                        item.SetDropRate(extraOutputConfig.DropDescription);
                        
                    }
                }

                if (self.CurWorkPeople != null)
                {
                    int amount = GatherOperate.GetPeopleProduceAmount(unit, new List<long>() { self.CurWorkPeople.Id },
                        resourceConfig.BaseEfficient);
                    self.FUIResourceWindow.m_CurEfficient.text = $"{amount}/{resourceConfig.OutInterval}s";
                }

                self.FUIResourceWindow.m_BaseEfficient.text = $"{resourceConfig.BaseEfficient}/{resourceConfig.OutInterval}s";
                self.UpdateResAmount(info.GatherAmount, info.MaxAmount);
            }
        }

        private static void UpdateResAmount(this FUIResourceWindowComponent self, int gatherAmount, int maxAmount)
        {
            self.FUIResourceWindow.m_ResTotalNum.text = $"{maxAmount - gatherAmount}/{maxAmount}";
            self.FUIResourceWindow.m_ProduceLabel.text = $"{gatherAmount}/{maxAmount}";
            self.FUIResourceWindow.m_ProduceProgress.FGComp.max = maxAmount;
            self.FUIResourceWindow.m_ProduceProgress.FGComp.value = gatherAmount;
        }

        public static void SetCurWorker(this FUIResourceWindowComponent self, People people)
        {
            self.CurWorkPeople = people;
            self.FUIResourceWindow.m_hasPeople.selectedIndex = 1;
            self.FUIResourceWindow.m_WorkPeopleIcon.url = PeopleViewHelper.GetHeadIconUrlByGender(people.GetGender());
            self.FUIResourceWindow.m_WorkerName.text = people.Name;

            var unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var resourceConfig = ResourcesConfigCategory.Instance.Get(self.CurSelectResId);
            int amount = GatherOperate.GetPeopleProduceAmount(unit, new List<long>() { self.CurWorkPeople.Id },
                resourceConfig.BaseEfficient);
            self.FUIResourceWindow.m_CurEfficient.text = $"{amount}/{resourceConfig.OutInterval}s";
        }

        public static void OnDetailButtonClick(this FUIResourceWindowComponent self)
        {
            var resourceConfig = self.ResourcePoint.Config;
            self.FUIResourceWindow.m_ResourceInfoPopup.m_Name.text = resourceConfig.ResourcesPointName;
            self.FUIResourceWindow.m_ResourceInfoPopup.m_Desc.text = resourceConfig.Description;
            self.FUIResourceWindow.m_ResourceInfoPopup.Visible = true;
            GRoot.inst.ShowPopup(self.FUIResourceWindow.m_ResourceInfoPopup.FGComp, self.FUIResourceWindow.m_DetialButton.FGComp);
        }

        public static void OnAddPeopleButtonClick(this FUIResourceWindowComponent self)
        {
            self.ShowSelectPeopleWindow().Coroutine();
        }
        
        public static async ETTask ShowSelectPeopleWindow(this FUIResourceWindowComponent self)
        {
            var selectWorkerWin = FUIComponent.Instance.ShowWindow<FUI_SelectWorkerWindow, FUISelectWorkerWindowComponent>();
            var workers = await selectWorkerWin.ShowAsync(1);

            if (workers.Count > 0)
            {
                var curSelectedPeopleId = workers[0];
                Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
                var peopleComp = unit.GetComponent<PeopleComponent>();
                var people = peopleComp.GetChild<People>(curSelectedPeopleId);
                var peopleViewComp = people.GetComponent<PeopleViewComponent>();

                var resourceComp = unit.GetComponent<ResourcePointComponent>();
                var resourceViewComp = resourceComp.GetChild<ResourcePoint>(self.ResourcePoint.Id)?.GetComponent<ResourceViewComponent>();

                List<long> gatherPeoples = new List<long>();
                gatherPeoples.Add(curSelectedPeopleId);
                int result = await GatherHelper.GatherResource(unit, self.ResourcePoint.Id, self.CurSelectResId, gatherPeoples);

                if (result != ErrorCode.ERR_Success)
                {
                    return;
                }

                self.SetCurWorker(people);
            

                peopleViewComp.MoveToPos(resourceViewComp.GetWorkerPos());
            }

        }
        

        public static async ETTask OnCancelWorkerButtonClick(this FUIResourceWindowComponent self)
        {
            self.FUIResourceWindow.m_hasPeople.selectedIndex = 0;

            if (self.CurWorkPeople == null)
            {
                return;
            }

            var unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var gatherComp = unit.GetComponent<GatherComponent>();
            var gather = gatherComp.GetherByResPointId(self.ResourcePoint.Id);
            await GatherHelper.StopGather(unit, gather.Id, self.CurWorkPeople.Id);
            
            self.CurWorkPeople = null;
        }
        
        public static async ETTask OnRemoveButtonClick(this FUIResourceWindowComponent self)
        {
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            await ResourceHelper.RootOutResource(unit, self.ResourcePoint.Id);
            self.Window.Hide();
        }

        public static void UpdateProgress(this FUIResourceWindowComponent self)
        {
            if (self.ResourcePoint.IsDisposed)
            {
                return;
            }

            if (self.ResourcePoint.ResAttriDic.TryGetValue(self.CurSelectResId, out ResourceAttri resourceAttr))
            {
                self.UpdateResAmount(resourceAttr.GatherAmount, resourceAttr.MaxAmount);
            }
        }
    } 
                
}