/** This is an automatically generated class by FairyGUI. Please do not modify it. **/

using ET.FUIBuilding;
using ET.FUIMain;
using FairyGUI;
using UnityEngine;

namespace ET
{
    using FUIStoreHouse;
    public class FUIStoreHouseWindowComponentAwakeSystem : AwakeSystem<FUIStoreHouseWindowComponent>
    {
        public override void Awake(FUIStoreHouseWindowComponent self)
        {
            self.Awake();
        }
    }
                
    [FriendClass(typeof(StoreItem))]
    [FriendClass(typeof(FUI_StoreItemDetailPopup))]
    [FriendClass(typeof(Item))]
    [FriendClass(typeof(FUI_StoreHouseGreenButton))]
    public static partial class FUIStoreHouseWindowComponentSystem
    {
        public static void Awake(this FUIStoreHouseWindowComponent self)
        {
            self.FUIStoreHouseWindow = self.Parent.GetComponent<FUI_StoreHouseWindow>();
            UIObjectFactory.SetPackageItemExtension(FUIPackage.StoreHouse_StoreItem, typeof(StoreItem));
            

            FUIStoreHouseWindow win = new FUIStoreHouseWindow();
            win.OnWindowShow = self.OnWindowShow;
            
            self.Window = win;
            self.Window.contentPane = self.FUIStoreHouseWindow.FGComp;

            self.FUIStoreHouseWindow.m_StoreItemInfoPopup.Visible = false;
        }

        public static void OnWindowShow(this FUIStoreHouseWindowComponent self)
        {
            // 加载所有Item资源
            self.ZoneScene().GetComponent<FUIPackageComponent>().AddPackage(FUIPackage.AllItem);
            
            self.ShowItems().Coroutine();
        }

        public static async ETTask ShowItems(this FUIStoreHouseWindowComponent self)
        {
            var list = self.FUIStoreHouseWindow.m_StoreItemList;
            list.RemoveChildrenToPool();

            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            await StoreHelper.GetStore(unit);
            var sc = unit.GetComponent<StoreComponent>();

            foreach (var v in sc.Children.Values)
            {
                var item = (Item) v;
                StoreItem storeItem = (StoreItem)list.AddItemFromPool();
                storeItem.data = item;
                var itemConfig = AllItemConfigCategory.Instance.Get(item.ConfigId);
                storeItem.SetName(itemConfig.Name);
                storeItem.SetAmount(item.Amount);
                storeItem.SetIcon($"ui://AllItem/{itemConfig.Icon}");
                
                // event
                storeItem.onRollOver.Set(self.OnStoreItemHoverIn);
                storeItem.onRollOut.Set(self.OnStoreItemHoverOut);

                //点击事件
                storeItem.onClick.Set(self.OnStoreItemClicked);
            }
        }

        public static void OnStoreItemClicked(this FUIStoreHouseWindowComponent self, EventContext context)
        {
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            StoreItem storeItem = context.sender as StoreItem;
            Item item = (Item)storeItem.data;
            var itemConfig = AllItemConfigCategory.Instance.Get(item.ConfigId);
            switch ((ItemType)itemConfig.RelatedTable)
            {
                case ItemType.Cuisine:
                    {
                        EventCallback0 callback = async () => {
                            Log.Warning($"食用{itemConfig.Name}");
                            //TODO - 发送服务器请求
                            var result = await StoreHelper.UseItem(unit, itemConfig.Id, 1);
                            Log.Warning($"道具使用:{result}");
                            if (result == ErrorCode.ERR_Success)
                            {
                                self.ShowItems().Coroutine();
                            }
                            self.FUIStoreHouseWindow.m_StoreItemDetailPopup.FGComp.visible = false;
                        };

                        CuisineConfig cuisineConfig = CuisineConfigCategory.Instance.Get(itemConfig.RelatedId);
                        var popup = self.FUIStoreHouseWindow.m_StoreItemDetailPopup;
                        popup.m_Icon.url = $"ui://AllItem/{itemConfig.Icon}";
                        popup.m_Name.text = itemConfig.Name;
                        popup.m_Nutrition.SetVar("value", cuisineConfig.NutritiveValue.ToString()).FlushVars();
                        popup.m_TranformValue.SetVar("value", cuisineConfig.FoodNum.ToString()).FlushVars();
                        popup.m_Description.text = itemConfig.Description;
                        popup.m_UsingBtn.FGComp.onClick.Set(callback);

                        self.FUIStoreHouseWindow.m_StoreItemDetailPopup.FGComp.visible = true;
                        GRoot.inst.ShowPopup(self.FUIStoreHouseWindow.m_StoreItemDetailPopup.FGComp, storeItem);
                    }
                    break;
                case ItemType.FunctionItem:
                {
                    self.Window.Hide();

                    FunctionItemConfig funcItemConfig = FunctionItemConfigCategory.Instance.Get(itemConfig.RelatedId);
                    // 种幼苗
                    if (funcItemConfig.UseType == 1)
                    {
                        var saplingConfigId = funcItemConfig.UseTypeParameter;
                        
                        // 添加编辑控件
                        var createResourceComp = self.ZoneScene().CurrentScene().AddComponent<UseSaplingItemComponent>();
                        createResourceComp.Edit(saplingConfigId, itemConfig.Id);
                    }
                    
                }
                    break;
            }
        }

        public static void OnStoreItemHoverIn(this FUIStoreHouseWindowComponent self, EventContext context)
        {
            StoreItem storeItem = context.sender as StoreItem;
            Item item = (Item) storeItem.data;
            var itemConfig = AllItemConfigCategory.Instance.Get(item.ConfigId);
            self.FUIStoreHouseWindow.m_StoreItemInfoPopup.m_Name.text = itemConfig.Name;
            self.FUIStoreHouseWindow.m_StoreItemInfoPopup.m_Desc.text = itemConfig.Description;
            self.FUIStoreHouseWindow.m_StoreItemInfoPopup.FGComp.visible = true;
            GRoot.inst.ShowPopup(self.FUIStoreHouseWindow.m_StoreItemInfoPopup.FGComp, storeItem);
        }

        public static void OnStoreItemHoverOut(this FUIStoreHouseWindowComponent self)
        {
            GRoot.inst.HidePopup(self.FUIStoreHouseWindow.m_StoreItemInfoPopup.FGComp);
        }
    } 
                
}