﻿namespace ET.PeopleBehave
{
    [Behave(ConstBehaveType.BEHAVE_IDLE)]
    public class Behave_Idle : BehaveBase
    {
        public override void Handle(People people)
        {
            PeopleViewComponent pView = people.GetComponent<PeopleViewComponent>();
            if (pView != null)
            {
                pView.SetNavEnable(true);
                pView.Stop();
            }
            
            var pAnimator = people.GetComponent<PeopleAnimatorComponent>();
            if (pAnimator == null)
            {
                return;
            }
            
            pAnimator.StopAll();
            pAnimator.PlayAnimation(PeopleAnimEnum.Idle);
        }
    }
}