﻿namespace ET.PeopleBehave
{
    [Behave(ConstBehaveType.BEHAVE_PREPARE_CABIN)]
    public class Behave_Prepare_Cabin : BehaveBase
    {
        public override void Handle(People people)
        {
            PeopleViewComponent pView = people.GetComponent<PeopleViewComponent>();
            if (pView == null)
            {
                return;
            }
            
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(people.ZoneScene());
            
            // 为cabin
            long targetId = people.GetTargetId();
            var cabin = unit.GetGrandChild<Cabin>(targetId);

            if (cabin != null)
            {
                Building building = cabin.GetParent<Building>();

                if (building != null)
                {
                    var bView = building.GetComponent<BuildingViewComponent>();
                    pView.MoveToPos(bView.GetWorkPos());
                }
            }

            var pAnimator = people.GetComponent<PeopleAnimatorComponent>();
            if (pAnimator == null)
            {
                return;
            }
            pAnimator.StopAll();
            pAnimator.PlayAnimation(PeopleAnimEnum.Run);
        }
    }
}