﻿namespace ET.PeopleBehave
{
    [Behave(ConstBehaveType.BEHAVE_PREPARE_GATHER)]
    [FriendClass(typeof(Gather))]
    [FriendClass(typeof(ResourcePoint))]
    public class Behave_Prepare_Gather : BehaveBase
    {
        public override void Handle(People people)
        {
            PeopleViewComponent pView = people.GetComponent<PeopleViewComponent>();
            if (pView == null)
            {
                return;
            }
            
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(people.ZoneScene());
            GatherComponent gc = unit.GetComponent<GatherComponent>();
            Gather gather = gc?.GetGatherByPeopleId(people.Id);
            if (gather != null && gather.PreparePeopleIdList.Contains(people.Id))
            {
                ResourcePointComponent rc = unit.GetComponent<ResourcePointComponent>();
                var resource = rc.GetChild<ResourcePoint>(gather.ResPointId);
                var resourceViewComp = resource.GetComponent<ResourceViewComponent>();
                if (resourceViewComp == null)
                {
                    Log.Error($"Can't find resourceViewComp of {resource.Id} : {resource.ConfigId}");
                }


                pView.MoveToPos(resourceViewComp.GetWorkerPos());
            }
            
            var pAnimator = people.GetComponent<PeopleAnimatorComponent>();
            if (pAnimator == null)
            {
                return;
            }
            pAnimator.StopAll();
            pAnimator.PlayAnimation(PeopleAnimEnum.Run);
        }
    }
}