
using System.Collections.Generic;
using ET.EventType;

namespace ET
{
    public struct SkillUseInfo
    {
        public Fighter Atker;
        public Skill Skill;
    }
    
    [ChildType(typeof(Fighter))]
    public class Battle: Entity, IAwake
    {
        public Dictionary<int, Fighter> FighterPosDic=new Dictionary<int, Fighter>();
        public Dictionary<int, Fighter> EnemyPosDic=new Dictionary<int, Fighter>();
        public Dictionary<long, Fighter> FighterDic=new Dictionary<long, Fighter>();
        public Dictionary<long, Fighter> EnemyDic=new Dictionary<long, Fighter>();
        public List<Fighter> FightList=new List<Fighter>();
        public bool AtkTrigger = false; //攻击方触发是否触发过
        public bool DefTrigger = false;//防御方是否触发过
        public int BattleType = 0; //1.PVP,2PVE
        public TurnInfo TurnInfo; //单个人完整攻击（包含反击，追击）
        public AtkInfo AtkInfo;  //单次攻击（比如一次主动攻击，一次反击，一次追击）
        public int BattleRound=0;  //战斗的总回合数
        public bool BAtkBack = false; //是否触发反击
        public bool BAtkAdd = false; //是否触发追击
        public Fighter Defer = null; //目标单位
        public Fighter AtkAdder = null; //追击人员
        public Fighter InterveneFighter = null; //援护人员
        public int BattleState = 0;
        public int AtkIndex = 0;
        public ValleyRandom random = new ValleyRandom();
        public bool IsInterrupt = false;  //是否打断
        public double CritValue=1.0;    //暴击值
        public bool IsIntervene = false;
        public Queue<SkillUseInfo> SkillUseQueue = new Queue<SkillUseInfo>(); //技能释放队列
        public Dictionary<long,Fighter> AliveFightDic = new Dictionary<long, Fighter>(); //所有的存活fighter
        public long EnemyId;
        public Dictionary<int, int> DropDic = new Dictionary<int, int>();


    }
}