﻿using MongoDB.Bson.Serialization.Attributes;
using UnityEngine;

namespace ET
{
    public enum BuildingState
    {
        Building = 0,
        Built = 1,
        Fix = 2,
        Upgrade = 3,
    }

    [ChildType]
    public class Building: Entity, IAwake, ISerializeToEntity
    {
        public int ConfigId;
        public Vector2 Position;
        public int Durable;
        public int IsUpgrade;
        
        [BsonIgnore]
        public StructureConfig Config => StructureConfigCategory.Instance.Get(this.ConfigId);
    }
}