﻿using System.Collections.Generic;
using MongoDB.Bson.Serialization.Attributes;
using UnityEngine;

namespace ET
{
    public class Construct : Entity, IAwake, ISerializeToEntity
    {
        public float X;
        public float Y;
        public long UpdateTime;
        public float ConstructSpeed;
        public int ConfigId;
        public int IsConstructed = 0; //1表示有人建造过
        public int Progress = 0;     //进度
        public int AddEfficiency = 0;     //效率
        public List<long> PeopleIdList = new List<long>();  // 已经进行建造的人
        public List<long> PreparePeopleIdList = new List<long>();   // 在去建造目标路上的人
        public long BuildingId;  //升级建筑的时候用
        [BsonIgnore]
        public SynthesisConfig Config => SynthesisConfigCategory.Instance.Get(this.ConfigId);

        [BsonIgnore]
        public bool IsUpgrade => this.BuildingId > 0;  //是不是升级建筑
    }
}