﻿using System;
using System.Collections.Generic;

namespace ET
{
    //战斗实体，这个用来处理战斗逻辑
    public class Fighter: Entity, IAwake
    {
        public string Name;
        public int ConfigId;
        public int Pos; //1-9,阵容的站位
        public bool IsAlive; //true表示活着
        public int Camp; //1表示自己这方
        public int AtkSpeed;
        public int FightType;
        

        public Dictionary<int, List<Modifier>> ModifierDic = new Dictionary<int, List<Modifier>>();
        public RoleConfig Config => RoleConfigCategory.Instance.Get(this.ConfigId);
        public MonsterConfig MonsterConfig=>MonsterConfigCategory.Instance.Get(this.ConfigId);

        public AttributesGroupConfig AttriConfig
        {
            get
            {
                if (this.Config != null)
                {
                    return AttributesGroupConfigCategory.Instance.Get(this.Config.AttributesGroup);
                }

                return null;
            }
        }

        public int UnarmedAttackId
        {
            get
            {
                if (this.AttriConfig != null)
                {
                   // return this.AttriConfig.UnarmedAttack;
                   return 0;
                }

                return 0;
            }
        }

        public int AtkId;
    }
}