using ET;
using ProtoBuf;
using System.Collections.Generic;
namespace ET
{
	[ResponseType(nameof(M2C_TestResponse))]
	[Message(OuterOpcode.C2M_TestRequest)]
	[ProtoContract]
	public partial class C2M_TestRequest: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public string request { get; set; }

	}

	[Message(OuterOpcode.M2C_TestResponse)]
	[ProtoContract]
	public partial class M2C_TestResponse: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public string response { get; set; }

	}

	[ResponseType(nameof(Actor_TransferResponse))]
	[Message(OuterOpcode.Actor_TransferRequest)]
	[ProtoContract]
	public partial class Actor_TransferRequest: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public int MapIndex { get; set; }

	}

	[Message(OuterOpcode.Actor_TransferResponse)]
	[ProtoContract]
	public partial class Actor_TransferResponse: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(G2C_EnterMap))]
	[Message(OuterOpcode.C2G_EnterMap)]
	[ProtoContract]
	public partial class C2G_EnterMap: Object, IRequest
	{
		[ProtoMember(1)]
		public int RpcId { get; set; }

	}

	[Message(OuterOpcode.G2C_EnterMap)]
	[ProtoContract]
	public partial class G2C_EnterMap: Object, IResponse
	{
		[ProtoMember(1)]
		public int RpcId { get; set; }

		[ProtoMember(2)]
		public int Error { get; set; }

		[ProtoMember(3)]
		public string Message { get; set; }

// 自己unitId
		[ProtoMember(4)]
		public long MyId { get; set; }

	}

	[Message(OuterOpcode.MoveInfo)]
	[ProtoContract]
	public partial class MoveInfo: Object
	{
		[ProtoMember(1)]
		public List<float> X = new List<float>();

		[ProtoMember(2)]
		public List<float> Y = new List<float>();

		[ProtoMember(3)]
		public List<float> Z = new List<float>();

		[ProtoMember(4)]
		public float A { get; set; }

		[ProtoMember(5)]
		public float B { get; set; }

		[ProtoMember(6)]
		public float C { get; set; }

		[ProtoMember(7)]
		public float W { get; set; }

		[ProtoMember(8)]
		public int TurnSpeed { get; set; }

	}

	[Message(OuterOpcode.BuildingProto)]
	[ProtoContract]
	public partial class BuildingProto: Object
	{
		[ProtoMember(1)]
		public long Id { get; set; }

		[ProtoMember(2)]
		public int ConfigId { get; set; }

		[ProtoMember(3)]
		public float X { get; set; }

		[ProtoMember(4)]
		public float Y { get; set; }

		[ProtoMember(5)]
		public int Durable { get; set; }

		[ProtoMember(6)]
		public FarmlandProto Farmland { get; set; }

		[ProtoMember(7)]
		public int IsUpgrade { get; set; }

		[ProtoMember(8)]
		public CabinProto Cabin { get; set; }

	}

	[Message(OuterOpcode.PeopleProto)]
	[ProtoContract]
	public partial class PeopleProto: Object
	{
		[ProtoMember(1)]
		public long Id { get; set; }

		[ProtoMember(2)]
		public string Name { get; set; }

		[ProtoMember(3)]
		public int ConfigId { get; set; }

		[ProtoMember(4)]
		public int LaborLevel { get; set; }

		[ProtoMember(5)]
		public int LaborExp { get; set; }

		[ProtoMember(6)]
		public int Level { get; set; }

		[ProtoMember(7)]
		public int Exp { get; set; }

		[ProtoMember(8)]
		public int Age { get; set; }

		[ProtoMember(9)]
		public int BehaveType { get; set; }

		[ProtoMember(10)]
		public long TargetId { get; set; }

		[ProtoMember(11)]
		public float X { get; set; }

		[ProtoMember(12)]
		public float Y { get; set; }

		[ProtoMember(16)]
		public List<SkillProto> SkillList = new List<SkillProto>();

	}

	[Message(OuterOpcode.ResAttriProto)]
	[ProtoContract]
	public partial class ResAttriProto: Object
	{
		[ProtoMember(1)]
		public int ConfigId { get; set; }

		[ProtoMember(2)]
		public int CurrAmount { get; set; }

		[ProtoMember(3)]
		public int MaxAmount { get; set; }

	}

	[Message(OuterOpcode.ResourceProto)]
	[ProtoContract]
	public partial class ResourceProto: Object
	{
		[ProtoMember(1)]
		public long Id { get; set; }

		[ProtoMember(2)]
		public int ConfigId { get; set; }

		[ProtoMember(3)]
		public float X { get; set; }

		[ProtoMember(4)]
		public float Y { get; set; }

		[ProtoMember(5)]
		public int MatureState { get; set; }

		[ProtoMember(6)]
		public long MonsterGroupId { get; set; }

		[ProtoMember(7)]
		public List<ResAttriProto> resAttriList = new List<ResAttriProto>();

	}

	[Message(OuterOpcode.ItemProto)]
	[ProtoContract]
	public partial class ItemProto: Object
	{
		[ProtoMember(1)]
		public long Id { get; set; }

		[ProtoMember(2)]
		public int ConfigId { get; set; }

		[ProtoMember(3)]
		public long Amount { get; set; }

		[ProtoMember(4)]
		public long CreateTime { get; set; }

	}

	[Message(OuterOpcode.GatherProto)]
	[ProtoContract]
	public partial class GatherProto: Object
	{
		[ProtoMember(1)]
		public long Id { get; set; }

		[ProtoMember(2)]
		public long ResPointId { get; set; }

		[ProtoMember(3)]
		public List<long> PeopleIdList = new List<long>();

		[ProtoMember(4)]
		public List<long> PreparePeopleIdList = new List<long>();

		[ProtoMember(5)]
		public int ResConfigId { get; set; }

	}

	[Message(OuterOpcode.ConstructProto)]
	[ProtoContract]
	public partial class ConstructProto: Object
	{
		[ProtoMember(1)]
		public long Id { get; set; }

		[ProtoMember(2)]
		public float X { get; set; }

		[ProtoMember(3)]
		public float Y { get; set; }

		[ProtoMember(4)]
		public long UpdateTime { get; set; }

		[ProtoMember(5)]
		public float ConStructSpeed { get; set; }

		[ProtoMember(6)]
		public int ConfigId { get; set; }

		[ProtoMember(7)]
		public int IsConstructed { get; set; }

		[ProtoMember(8)]
		public int Progress { get; set; }

		[ProtoMember(9)]
		public List<long> PeopleIdList = new List<long>();

		[ProtoMember(10)]
		public List<long> PreparePeopleIdList = new List<long>();

		[ProtoMember(11)]
		public long BuildingId { get; set; }

	}

	[Message(OuterOpcode.SynthesisProto)]
	[ProtoContract]
	public partial class SynthesisProto: Object
	{
		[ProtoMember(1)]
		public int ConfigId { get; set; }

		[ProtoMember(2)]
		public long UpdateTime { get; set; }

		[ProtoMember(3)]
		public long CurrAmount { get; set; }

		[ProtoMember(4)]
		public long MaxAmount { get; set; }

		[ProtoMember(5)]
		public int Progress { get; set; }

		[ProtoMember(6)]
		public int State { get; set; }

	}

	[Message(OuterOpcode.MenuProto)]
	[ProtoContract]
	public partial class MenuProto: Object
	{
		[ProtoMember(1)]
		public int ConfigId { get; set; }

		[ProtoMember(2)]
		public int Proficiency { get; set; }

		[ProtoMember(3)]
		public int State { get; set; }

	}

	[Message(OuterOpcode.PrescriptionProto)]
	[ProtoContract]
	public partial class PrescriptionProto: Object
	{
		[ProtoMember(1)]
		public int ConfigId { get; set; }

		[ProtoMember(2)]
		public int Proficiency { get; set; }

		[ProtoMember(3)]
		public int State { get; set; }

	}

	[Message(OuterOpcode.UnitProto)]
	[ProtoContract]
	public partial class UnitProto: Object
	{
		[ProtoMember(1)]
		public long Id { get; set; }

		[ProtoMember(2)]
		public long Food { get; set; }

		[ProtoMember(3)]
		public long Water { get; set; }

		[ProtoMember(4)]
		public int SilverTael { get; set; }

		[ProtoMember(5)]
		public int GoldIngot { get; set; }

		[ProtoMember(6)]
		public int Season { get; set; }

		[ProtoMember(7)]
		public int GameTime { get; set; }

		[ProtoMember(8)]
		public List<BuildingProto> Buildings = new List<BuildingProto>();

		[ProtoMember(9)]
		public List<PeopleProto> PeopleList = new List<PeopleProto>();

		[ProtoMember(10)]
		public List<ResourceProto> ResourceList = new List<ResourceProto>();

		[ProtoMember(11)]
		public List<ItemProto> Store = new List<ItemProto>();

		[ProtoMember(12)]
		public List<GatherProto> GatherList = new List<GatherProto>();

		[ProtoMember(13)]
		public List<ConstructProto> ConstructList = new List<ConstructProto>();

		[ProtoMember(14)]
		public List<SynthesisProto> SynthesisList = new List<SynthesisProto>();

		[ProtoMember(15)]
		public List<MenuProto> MenuList = new List<MenuProto>();

		[ProtoMember(16)]
		public List<PrescriptionProto> PrescriptionList = new List<PrescriptionProto>();

		[ProtoMember(17)]
		public int Prosperity { get; set; }

		[ProtoMember(18)]
		public int Scale { get; set; }

		[ProtoMember(19)]
		public int Day { get; set; }

		[ProtoMember(20)]
		public string Name { get; set; }

		[ProtoMember(21)]
		public int EventSeed { get; set; }

		[ProtoMember(22)]
		public List<string> EventNames = new List<string>();

		[ProtoMember(24)]
		public List<long> FighterList = new List<long>();

		[ProtoMember(25)]
		public List<MonsterGroupProto> MonsterGroupList = new List<MonsterGroupProto>();

		[ProtoMember(26)]
		public WeatherProto Weather { get; set; }

	}

	[Message(OuterOpcode.M2C_CreateUnits)]
	[ProtoContract]
	public partial class M2C_CreateUnits: Object, IActorMessage
	{
		[ProtoMember(2)]
		public List<UnitProto> Units = new List<UnitProto>();

	}

	[Message(OuterOpcode.M2C_CreateMyUnit)]
	[ProtoContract]
	public partial class M2C_CreateMyUnit: Object, IActorMessage
	{
		[ProtoMember(1)]
		public UnitProto Unit { get; set; }

		[ProtoMember(2)]
		public long SceneInstanceId { get; set; }

		[ProtoMember(3)]
		public string SceneName { get; set; }

	}

	[Message(OuterOpcode.M2C_StartSceneChange)]
	[ProtoContract]
	public partial class M2C_StartSceneChange: Object, IActorMessage
	{
		[ProtoMember(1)]
		public long SceneInstanceId { get; set; }

		[ProtoMember(2)]
		public string SceneName { get; set; }

	}

	[Message(OuterOpcode.M2C_RemoveUnits)]
	[ProtoContract]
	public partial class M2C_RemoveUnits: Object, IActorMessage
	{
		[ProtoMember(2)]
		public List<long> Units = new List<long>();

	}

	[Message(OuterOpcode.C2M_PathfindingResult)]
	[ProtoContract]
	public partial class C2M_PathfindingResult: Object, IActorLocationMessage
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public float X { get; set; }

		[ProtoMember(2)]
		public float Y { get; set; }

		[ProtoMember(3)]
		public float Z { get; set; }

	}

	[Message(OuterOpcode.C2M_Stop)]
	[ProtoContract]
	public partial class C2M_Stop: Object, IActorLocationMessage
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

	}

	[Message(OuterOpcode.M2C_PathfindingResult)]
	[ProtoContract]
	public partial class M2C_PathfindingResult: Object, IActorMessage
	{
		[ProtoMember(1)]
		public long Id { get; set; }

		[ProtoMember(2)]
		public float X { get; set; }

		[ProtoMember(3)]
		public float Y { get; set; }

		[ProtoMember(4)]
		public float Z { get; set; }

		[ProtoMember(5)]
		public List<float> Xs = new List<float>();

		[ProtoMember(6)]
		public List<float> Ys = new List<float>();

		[ProtoMember(7)]
		public List<float> Zs = new List<float>();

	}

	[Message(OuterOpcode.M2C_Stop)]
	[ProtoContract]
	public partial class M2C_Stop: Object, IActorMessage
	{
		[ProtoMember(1)]
		public int Error { get; set; }

		[ProtoMember(2)]
		public long Id { get; set; }

		[ProtoMember(3)]
		public float X { get; set; }

		[ProtoMember(4)]
		public float Y { get; set; }

		[ProtoMember(5)]
		public float Z { get; set; }

		[ProtoMember(6)]
		public float A { get; set; }

		[ProtoMember(7)]
		public float B { get; set; }

		[ProtoMember(8)]
		public float C { get; set; }

		[ProtoMember(9)]
		public float W { get; set; }

	}

	[ResponseType(nameof(G2C_Ping))]
	[Message(OuterOpcode.C2G_Ping)]
	[ProtoContract]
	public partial class C2G_Ping: Object, IRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

	}

	[Message(OuterOpcode.G2C_Ping)]
	[ProtoContract]
	public partial class G2C_Ping: Object, IResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public long Time { get; set; }

	}

	[Message(OuterOpcode.G2C_Test)]
	[ProtoContract]
	public partial class G2C_Test: Object, IMessage
	{
	}

	[ResponseType(nameof(M2C_Reload))]
	[Message(OuterOpcode.C2M_Reload)]
	[ProtoContract]
	public partial class C2M_Reload: Object, IRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public string Account { get; set; }

		[ProtoMember(2)]
		public string Password { get; set; }

	}

	[Message(OuterOpcode.M2C_Reload)]
	[ProtoContract]
	public partial class M2C_Reload: Object, IResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(R2C_Login))]
	[Message(OuterOpcode.C2R_Login)]
	[ProtoContract]
	public partial class C2R_Login: Object, IRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public string Account { get; set; }

		[ProtoMember(2)]
		public string Password { get; set; }

	}

	[Message(OuterOpcode.R2C_Login)]
	[ProtoContract]
	public partial class R2C_Login: Object, IResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public string Address { get; set; }

		[ProtoMember(2)]
		public long Key { get; set; }

		[ProtoMember(3)]
		public long GateId { get; set; }

	}

	[ResponseType(nameof(G2C_LoginGate))]
	[Message(OuterOpcode.C2G_LoginGate)]
	[ProtoContract]
	public partial class C2G_LoginGate: Object, IRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long Key { get; set; }

		[ProtoMember(2)]
		public long GateId { get; set; }

	}

	[Message(OuterOpcode.G2C_LoginGate)]
	[ProtoContract]
	public partial class G2C_LoginGate: Object, IResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public long PlayerId { get; set; }

	}

	[Message(OuterOpcode.G2C_TestHotfixMessage)]
	[ProtoContract]
	public partial class G2C_TestHotfixMessage: Object, IMessage
	{
		[ProtoMember(1)]
		public string Info { get; set; }

	}

	[ResponseType(nameof(M2C_TestRobotCase))]
	[Message(OuterOpcode.C2M_TestRobotCase)]
	[ProtoContract]
	public partial class C2M_TestRobotCase: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public int N { get; set; }

	}

	[Message(OuterOpcode.M2C_TestRobotCase)]
	[ProtoContract]
	public partial class M2C_TestRobotCase: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public int N { get; set; }

	}

	[ResponseType(nameof(M2C_TransferMap))]
	[Message(OuterOpcode.C2M_TransferMap)]
	[ProtoContract]
	public partial class C2M_TransferMap: Object, IActorLocationRequest
	{
		[ProtoMember(1)]
		public int RpcId { get; set; }

	}

	[Message(OuterOpcode.M2C_TransferMap)]
	[ProtoContract]
	public partial class M2C_TransferMap: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(A2C_LoginAccount))]
	[Message(OuterOpcode.C2A_LoginAccount)]
	[ProtoContract]
	public partial class C2A_LoginAccount: Object, IRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public string AccountName { get; set; }

		[ProtoMember(2)]
		public string Password { get; set; }

	}

	[Message(OuterOpcode.A2C_LoginAccount)]
	[ProtoContract]
	public partial class A2C_LoginAccount: Object, IResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public string Token { get; set; }

		[ProtoMember(2)]
		public long AccountId { get; set; }

	}

	[Message(OuterOpcode.A2C_Disconnect)]
	[ProtoContract]
	public partial class A2C_Disconnect: Object, IMessage
	{
		[ProtoMember(1)]
		public int Error { get; set; }

	}

	[Message(OuterOpcode.ServerInfoProto)]
	[ProtoContract]
	public partial class ServerInfoProto: Object
	{
		[ProtoMember(1)]
		public int Id { get; set; }

		[ProtoMember(2)]
		public int Status { get; set; }

		[ProtoMember(3)]
		public string ServerName { get; set; }

	}

	[ResponseType(nameof(A2C_ServerInfosResponse))]
	[Message(OuterOpcode.C2A_ServerInfosRequest)]
	[ProtoContract]
	public partial class C2A_ServerInfosRequest: Object, IRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public string Token { get; set; }

		[ProtoMember(2)]
		public long AccountId { get; set; }

	}

	[Message(OuterOpcode.A2C_ServerInfosResponse)]
	[ProtoContract]
	public partial class A2C_ServerInfosResponse: Object, IResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public List<ServerInfoProto> ServerInfoList = new List<ServerInfoProto>();

	}

	[Message(OuterOpcode.RoleInfoProto)]
	[ProtoContract]
	public partial class RoleInfoProto: Object
	{
		[ProtoMember(1)]
		public long Id { get; set; }

		[ProtoMember(2)]
		public string Name { get; set; }

		[ProtoMember(3)]
		public int State { get; set; }

		[ProtoMember(4)]
		public long AccountId { get; set; }

		[ProtoMember(5)]
		public long LastLoginTime { get; set; }

		[ProtoMember(6)]
		public long CreateTime { get; set; }

		[ProtoMember(7)]
		public int ServerId { get; set; }

	}

	[ResponseType(nameof(A2C_CreateRole))]
	[Message(OuterOpcode.C2A_CreateRole)]
	[ProtoContract]
	public partial class C2A_CreateRole: Object, IRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public string Token { get; set; }

		[ProtoMember(2)]
		public long AccountId { get; set; }

		[ProtoMember(3)]
		public string Name { get; set; }

		[ProtoMember(4)]
		public int ServerId { get; set; }

		[ProtoMember(5)]
		public int Gender { get; set; }

	}

	[Message(OuterOpcode.A2C_CreateRole)]
	[ProtoContract]
	public partial class A2C_CreateRole: Object, IResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public RoleInfoProto RoleInfo { get; set; }

	}

	[ResponseType(nameof(A2C_GetRoles))]
	[Message(OuterOpcode.C2A_GetRoles)]
	[ProtoContract]
	public partial class C2A_GetRoles: Object, IRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public string Token { get; set; }

		[ProtoMember(2)]
		public long AccountId { get; set; }

		[ProtoMember(3)]
		public int ServerId { get; set; }

	}

	[Message(OuterOpcode.A2C_GetRoles)]
	[ProtoContract]
	public partial class A2C_GetRoles: Object, IResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public List<RoleInfoProto> RoleInfo = new List<RoleInfoProto>();

	}

	[ResponseType(nameof(A2C_DeleteRole))]
	[Message(OuterOpcode.C2A_DeleteRole)]
	[ProtoContract]
	public partial class C2A_DeleteRole: Object, IRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public string Token { get; set; }

		[ProtoMember(2)]
		public long AccountId { get; set; }

		[ProtoMember(3)]
		public int ServerId { get; set; }

		[ProtoMember(4)]
		public long RoleInfoId { get; set; }

	}

	[Message(OuterOpcode.A2C_DeleteRole)]
	[ProtoContract]
	public partial class A2C_DeleteRole: Object, IResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public long DeletedRoleInfoId { get; set; }

	}

	[ResponseType(nameof(A2C_GetRealmKey))]
	[Message(OuterOpcode.C2A_GetRealmKey)]
	[ProtoContract]
	public partial class C2A_GetRealmKey: Object, IRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public string Token { get; set; }

		[ProtoMember(2)]
		public long AccountId { get; set; }

		[ProtoMember(3)]
		public int ServerId { get; set; }

	}

	[Message(OuterOpcode.A2C_GetRealmKey)]
	[ProtoContract]
	public partial class A2C_GetRealmKey: Object, IResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public string RealmKey { get; set; }

		[ProtoMember(2)]
		public string RealmAddress { get; set; }

	}

	[ResponseType(nameof(R2C_LoginRealm))]
	[Message(OuterOpcode.C2R_LoginRealm)]
	[ProtoContract]
	public partial class C2R_LoginRealm: Object, IRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long AccountId { get; set; }

		[ProtoMember(2)]
		public string RealmTokenKey { get; set; }

	}

	[Message(OuterOpcode.R2C_LoginRealm)]
	[ProtoContract]
	public partial class R2C_LoginRealm: Object, IResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public string GateSessionKey { get; set; }

		[ProtoMember(2)]
		public string GateAddress { get; set; }

	}

	[ResponseType(nameof(G2C_LoginGameGate))]
	[Message(OuterOpcode.C2G_LoginGameGate)]
	[ProtoContract]
	public partial class C2G_LoginGameGate: Object, IRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long AccountId { get; set; }

		[ProtoMember(2)]
		public long RoleId { get; set; }

		[ProtoMember(3)]
		public string GateTokenKey { get; set; }

	}

	[Message(OuterOpcode.G2C_LoginGameGate)]
	[ProtoContract]
	public partial class G2C_LoginGameGate: Object, IResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public long PlayerId { get; set; }

	}

	[ResponseType(nameof(G2C_EnterGame))]
	[Message(OuterOpcode.C2G_EnterGame)]
	[ProtoContract]
	public partial class C2G_EnterGame: Object, IRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

	}

	[Message(OuterOpcode.G2C_EnterGame)]
	[ProtoContract]
	public partial class G2C_EnterGame: Object, IResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public long UnitId { get; set; }

	}

	[ResponseType(nameof(M2C_RemoveBuilding))]
	[Message(OuterOpcode.C2M_RemoveBuilding)]
	[ProtoContract]
	public partial class C2M_RemoveBuilding: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long Id { get; set; }

	}

	[Message(OuterOpcode.M2C_RemoveBuilding)]
	[ProtoContract]
	public partial class M2C_RemoveBuilding: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public long Id { get; set; }

	}

	[ResponseType(nameof(M2C_GameTime))]
	[Message(OuterOpcode.C2M_GameTime)]
	[ProtoContract]
	public partial class C2M_GameTime: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

	}

	[Message(OuterOpcode.M2C_GameTime)]
	[ProtoContract]
	public partial class M2C_GameTime: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public int GameTime { get; set; }

	}

	[ResponseType(nameof(M2C_GatherResource))]
	[Message(OuterOpcode.C2M_GatherResource)]
	[ProtoContract]
	public partial class C2M_GatherResource: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long ResPointId { get; set; }

		[ProtoMember(2)]
		public List<long> PeopleIdList = new List<long>();

		[ProtoMember(3)]
		public int ResConfigId { get; set; }

	}

	[Message(OuterOpcode.M2C_GatherResource)]
	[ProtoContract]
	public partial class M2C_GatherResource: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public long GatherId { get; set; }

	}

	[ResponseType(nameof(M2C_StartGatherResource))]
	[Message(OuterOpcode.C2M_StartGatherResource)]
	[ProtoContract]
	public partial class C2M_StartGatherResource: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long GatherId { get; set; }

		[ProtoMember(2)]
		public long PeopleId { get; set; }

	}

	[Message(OuterOpcode.M2C_StartGatherResource)]
	[ProtoContract]
	public partial class M2C_StartGatherResource: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_StopGather))]
	[Message(OuterOpcode.C2M_StopGather)]
	[ProtoContract]
	public partial class C2M_StopGather: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long GatherId { get; set; }

		[ProtoMember(2)]
		public long PeopleId { get; set; }

	}

	[Message(OuterOpcode.M2C_StopGather)]
	[ProtoContract]
	public partial class M2C_StopGather: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[Message(OuterOpcode.M2C_RemoveEntity)]
	[ProtoContract]
	public partial class M2C_RemoveEntity: Object, IActorMessage
	{
		[ProtoMember(1)]
		public long Id { get; set; }

		[ProtoMember(2)]
		public int EntityType { get; set; }

	}

	[ResponseType(nameof(M2C_GetStore))]
	[Message(OuterOpcode.C2M_GetStore)]
	[ProtoContract]
	public partial class C2M_GetStore: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

	}

	[Message(OuterOpcode.M2C_GetStore)]
	[ProtoContract]
	public partial class M2C_GetStore: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(7)]
		public List<ItemProto> Store = new List<ItemProto>();

	}

	[ResponseType(nameof(M2C_PeopleMove))]
	[Message(OuterOpcode.C2M_PeopleMove)]
	[ProtoContract]
	public partial class C2M_PeopleMove: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long PeopleId { get; set; }

		[ProtoMember(2)]
		public float X { get; set; }

		[ProtoMember(3)]
		public float Y { get; set; }

	}

	[Message(OuterOpcode.M2C_PeopleMove)]
	[ProtoContract]
	public partial class M2C_PeopleMove: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[Message(OuterOpcode.M2C_NotifyUpdateConstructProgress)]
	[ProtoContract]
	public partial class M2C_NotifyUpdateConstructProgress: Object, IActorMessage
	{
		[ProtoMember(1)]
		public List<long> Ks = new List<long>();

		[ProtoMember(2)]
		public List<int> Vs = new List<int>();

	}

	[Message(OuterOpcode.M2C_UpdateGather)]
	[ProtoContract]
	public partial class M2C_UpdateGather: Object, IActorMessage
	{
		[ProtoMember(1)]
		public List<GatherProto> GatherList = new List<GatherProto>();

	}

	[ResponseType(nameof(M2C_CreateConstruct))]
	[Message(OuterOpcode.C2M_CreateConstruct)]
	[ProtoContract]
	public partial class C2M_CreateConstruct: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public int ConfigId { get; set; }

		[ProtoMember(2)]
		public float X { get; set; }

		[ProtoMember(3)]
		public float Y { get; set; }

		[ProtoMember(4)]
		public long BuildingId { get; set; }

	}

	[Message(OuterOpcode.M2C_CreateConstruct)]
	[ProtoContract]
	public partial class M2C_CreateConstruct: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public long Id { get; set; }

	}

	[ResponseType(nameof(M2C_CancelConstruct))]
	[Message(OuterOpcode.C2M_CancelConstruct)]
	[ProtoContract]
	public partial class C2M_CancelConstruct: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long Id { get; set; }

	}

	[Message(OuterOpcode.M2C_CancelConstruct)]
	[ProtoContract]
	public partial class M2C_CancelConstruct: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public long Id { get; set; }

	}

	[ResponseType(nameof(M2C_GoConstruct))]
	[Message(OuterOpcode.C2M_GoConstruct)]
	[ProtoContract]
	public partial class C2M_GoConstruct: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long Id { get; set; }

		[ProtoMember(2)]
		public List<long> PeopleIdList = new List<long>();

	}

	[Message(OuterOpcode.M2C_GoConstruct)]
	[ProtoContract]
	public partial class M2C_GoConstruct: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_StartConstruct))]
	[Message(OuterOpcode.C2M_StartConstruct)]
	[ProtoContract]
	public partial class C2M_StartConstruct: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long Id { get; set; }

		[ProtoMember(2)]
		public long peopleId { get; set; }

	}

	[Message(OuterOpcode.M2C_StartConstruct)]
	[ProtoContract]
	public partial class M2C_StartConstruct: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_StopConstruct))]
	[Message(OuterOpcode.C2M_StopConstruct)]
	[ProtoContract]
	public partial class C2M_StopConstruct: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long Id { get; set; }

		[ProtoMember(2)]
		public long peopleId { get; set; }

	}

	[Message(OuterOpcode.M2C_StopConstruct)]
	[ProtoContract]
	public partial class M2C_StopConstruct: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[Message(OuterOpcode.M2C_NotifyUpdatePeople)]
	[ProtoContract]
	public partial class M2C_NotifyUpdatePeople: Object, IActorMessage
	{
		[ProtoMember(1)]
		public long Id { get; set; }

		[ProtoMember(2)]
		public List<int> Ks = new List<int>();

		[ProtoMember(3)]
		public List<long> Vs = new List<long>();

	}

	[Message(OuterOpcode.M2C_NotifyConstructFinish)]
	[ProtoContract]
	public partial class M2C_NotifyConstructFinish: Object, IActorMessage
	{
		[ProtoMember(1)]
		public long ConstructId { get; set; }

		[ProtoMember(2)]
		public long BuildingId { get; set; }

		[ProtoMember(3)]
		public long ChildId { get; set; }

	}

	[Message(OuterOpcode.M2C_NotifyUpdateValley)]
	[ProtoContract]
	public partial class M2C_NotifyUpdateValley: Object, IActorMessage
	{
		[ProtoMember(1)]
		public List<int> Ks = new List<int>();

		[ProtoMember(2)]
		public List<long> Vs = new List<long>();

	}

	[Message(OuterOpcode.M2C_NotifyGatherFinish)]
	[ProtoContract]
	public partial class M2C_NotifyGatherFinish: Object, IActorMessage
	{
		[ProtoMember(1)]
		public long GatherId { get; set; }

	}

	[ResponseType(nameof(M2C_StartSynthesis))]
	[Message(OuterOpcode.C2M_StartSynthesis)]
	[ProtoContract]
	public partial class C2M_StartSynthesis: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public int ConfigId { get; set; }

		[ProtoMember(2)]
		public long MaxAmount { get; set; }

	}

	[Message(OuterOpcode.M2C_StartSynthesis)]
	[ProtoContract]
	public partial class M2C_StartSynthesis: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_GetSynthesis))]
	[Message(OuterOpcode.C2M_GetSynthesis)]
	[ProtoContract]
	public partial class C2M_GetSynthesis: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

	}

	[Message(OuterOpcode.M2C_GetSynthesis)]
	[ProtoContract]
	public partial class M2C_GetSynthesis: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public List<SynthesisProto> SynthesisList = new List<SynthesisProto>();

	}

	[ResponseType(nameof(M2C_EndSynthesis))]
	[Message(OuterOpcode.C2M_EndSynthesis)]
	[ProtoContract]
	public partial class C2M_EndSynthesis: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public int ConfigId { get; set; }

	}

	[Message(OuterOpcode.M2C_EndSynthesis)]
	[ProtoContract]
	public partial class M2C_EndSynthesis: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[Message(OuterOpcode.M2C_NotifySynthesisUpdate)]
	[ProtoContract]
	public partial class M2C_NotifySynthesisUpdate: Object, IActorMessage
	{
		[ProtoMember(2)]
		public List<ItemProto> Items = new List<ItemProto>();

	}

	[Message(OuterOpcode.M2C_NotifySynthesisWithState)]
	[ProtoContract]
	public partial class M2C_NotifySynthesisWithState: Object, IActorMessage
	{
		[ProtoMember(1)]
		public List<int> ConfigIds = new List<int>();

		[ProtoMember(2)]
		public int State { get; set; }

	}

	[ResponseType(nameof(M2C_Cheat))]
	[Message(OuterOpcode.C2M_Cheat)]
	[ProtoContract]
	public partial class C2M_Cheat: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public int Type { get; set; }

		[ProtoMember(2)]
		public int Id { get; set; }

		[ProtoMember(3)]
		public uint Num { get; set; }

	}

	[Message(OuterOpcode.M2C_Cheat)]
	[ProtoContract]
	public partial class M2C_Cheat: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_StartCuisine))]
	[Message(OuterOpcode.C2M_StartCuisine)]
	[ProtoContract]
	public partial class C2M_StartCuisine: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public int Id { get; set; }

		[ProtoMember(2)]
		public long MaxAmount { get; set; }

	}

	[Message(OuterOpcode.M2C_StartCuisine)]
	[ProtoContract]
	public partial class M2C_StartCuisine: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_DevelopRecipe))]
	[Message(OuterOpcode.C2M_DevelopRecipe)]
	[ProtoContract]
	public partial class C2M_DevelopRecipe: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public List<int> Ids = new List<int>();

	}

	[Message(OuterOpcode.M2C_DevelopRecipe)]
	[ProtoContract]
	public partial class M2C_DevelopRecipe: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public int Id { get; set; }

	}

	[ResponseType(nameof(M2C_StopRecipeGame))]
	[Message(OuterOpcode.C2M_StopRecipeGame)]
	[ProtoContract]
	public partial class C2M_StopRecipeGame: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public int Result { get; set; }

	}

	[Message(OuterOpcode.M2C_StopRecipeGame)]
	[ProtoContract]
	public partial class M2C_StopRecipeGame: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public int MixtureId { get; set; }

	}

	[ResponseType(nameof(M2C_GetMenu))]
	[Message(OuterOpcode.C2M_GetMenu)]
	[ProtoContract]
	public partial class C2M_GetMenu: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

	}

	[Message(OuterOpcode.M2C_GetMenu)]
	[ProtoContract]
	public partial class M2C_GetMenu: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public List<MenuProto> MenuList = new List<MenuProto>();

	}

	[ResponseType(nameof(M2C_DropItem))]
	[Message(OuterOpcode.C2M_DropItem)]
	[ProtoContract]
	public partial class C2M_DropItem: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public int ConfigId { get; set; }

		[ProtoMember(2)]
		public int Amount { get; set; }

	}

	[Message(OuterOpcode.M2C_DropItem)]
	[ProtoContract]
	public partial class M2C_DropItem: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_UseItem))]
	[Message(OuterOpcode.C2M_UseItem)]
	[ProtoContract]
	public partial class C2M_UseItem: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public int ConfigId { get; set; }

		[ProtoMember(2)]
		public int Amount { get; set; }

		[ProtoMember(3)]
		public long Id { get; set; }

	}

	[Message(OuterOpcode.M2C_UseItem)]
	[ProtoContract]
	public partial class M2C_UseItem: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_UpgradeScale))]
	[Message(OuterOpcode.C2M_UpgradeScale)]
	[ProtoContract]
	public partial class C2M_UpgradeScale: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

	}

	[Message(OuterOpcode.M2C_UpgradeScale)]
	[ProtoContract]
	public partial class M2C_UpgradeScale: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public int Scale { get; set; }

	}

	[Message(OuterOpcode.M2C_NotifyNightEvent)]
	[ProtoContract]
	public partial class M2C_NotifyNightEvent: Object, IActorMessage
	{
		[ProtoMember(1)]
		public int EventSeed { get; set; }

		[ProtoMember(2)]
		public int NightTime { get; set; }

		[ProtoMember(3)]
		public int Time { get; set; }

		[ProtoMember(4)]
		public List<string> EventNames = new List<string>();

	}

	[ResponseType(nameof(M2C_RootOutResource))]
	[Message(OuterOpcode.C2M_RootOutResource)]
	[ProtoContract]
	public partial class C2M_RootOutResource: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long ResourceId { get; set; }

	}

	[Message(OuterOpcode.M2C_RootOutResource)]
	[ProtoContract]
	public partial class M2C_RootOutResource: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_CreateResource))]
	[Message(OuterOpcode.C2M_CreateResource)]
	[ProtoContract]
	public partial class C2M_CreateResource: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public int ResourceConfigId { get; set; }

		[ProtoMember(2)]
		public float X { get; set; }

		[ProtoMember(3)]
		public float Y { get; set; }

	}

	[Message(OuterOpcode.M2C_CreateResource)]
	[ProtoContract]
	public partial class M2C_CreateResource: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public long ResourceId { get; set; }

	}

	[ResponseType(nameof(M2C_UseSaplingItem))]
	[Message(OuterOpcode.C2M_UseSaplingItem)]
	[ProtoContract]
	public partial class C2M_UseSaplingItem: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public int ItemId { get; set; }

		[ProtoMember(2)]
		public float X { get; set; }

		[ProtoMember(3)]
		public float Y { get; set; }

	}

	[Message(OuterOpcode.M2C_UseSaplingItem)]
	[ProtoContract]
	public partial class M2C_UseSaplingItem: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public long ResourceId { get; set; }

	}

	[ResponseType(nameof(M2C_Embattle))]
	[Message(OuterOpcode.C2M_Embattle)]
	[ProtoContract]
	public partial class C2M_Embattle: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public List<int> Ks = new List<int>();

		[ProtoMember(2)]
		public List<long> Vs = new List<long>();

	}

	[Message(OuterOpcode.M2C_Embattle)]
	[ProtoContract]
	public partial class M2C_Embattle: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_EnterBattle))]
	[Message(OuterOpcode.C2M_EnterBattle)]
	[ProtoContract]
	public partial class C2M_EnterBattle: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long EnemyId { get; set; }

		[ProtoMember(2)]
		public int BattleType { get; set; }

	}

	[Message(OuterOpcode.M2C_EnterBattle)]
	[ProtoContract]
	public partial class M2C_EnterBattle: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public List<FighterProto> FighterList = new List<FighterProto>();

		[ProtoMember(2)]
		public List<FighterProto> EnemyList = new List<FighterProto>();

		[ProtoMember(3)]
		public int Seed { get; set; }

		[ProtoMember(4)]
		public long BattleId { get; set; }

	}

	[Message(OuterOpcode.SkillProto)]
	[ProtoContract]
	public partial class SkillProto: Object
	{
		[ProtoMember(1)]
		public long Id { get; set; }

		[ProtoMember(2)]
		public int ConfigId { get; set; }

		[ProtoMember(3)]
		public int Level { get; set; }

		[ProtoMember(4)]
		public int CoolTime { get; set; }

	}

	[Message(OuterOpcode.FighterProto)]
	[ProtoContract]
	public partial class FighterProto: Object
	{
		[ProtoMember(1)]
		public long Id { get; set; }

		[ProtoMember(2)]
		public string Name { get; set; }

		[ProtoMember(3)]
		public int ConfigId { get; set; }

		[ProtoMember(4)]
		public int Pos { get; set; }

		[ProtoMember(5)]
		public bool IsAlive { get; set; }

		[ProtoMember(6)]
		public List<int> Ks = new List<int>();

		[ProtoMember(7)]
		public List<long> Vs = new List<long>();

		[ProtoMember(8)]
		public int AtkId { get; set; }

		[ProtoMember(9)]
		public List<SkillProto> SkillList = new List<SkillProto>();

		[ProtoMember(10)]
		public int FightType { get; set; }

	}

	[ResponseType(nameof(M2C_ExitBattle))]
	[Message(OuterOpcode.C2M_ExitBattle)]
	[ProtoContract]
	public partial class C2M_ExitBattle: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

	}

	[Message(OuterOpcode.M2C_ExitBattle)]
	[ProtoContract]
	public partial class M2C_ExitBattle: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_BattleAtkOver))]
	[Message(OuterOpcode.C2M_BattleAtkOver)]
	[ProtoContract]
	public partial class C2M_BattleAtkOver: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

	}

	[Message(OuterOpcode.M2C_BattleAtkOver)]
	[ProtoContract]
	public partial class M2C_BattleAtkOver: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public int Seed { get; set; }

	}

	[ResponseType(nameof(M2C_UseSkill))]
	[Message(OuterOpcode.C2M_UseSkill)]
	[ProtoContract]
	public partial class C2M_UseSkill: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long AtkId { get; set; }

		[ProtoMember(2)]
		public int SkillId { get; set; }

	}

	[Message(OuterOpcode.M2C_UseSkill)]
	[ProtoContract]
	public partial class M2C_UseSkill: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_TestReplaceSkill))]
	[Message(OuterOpcode.C2M_TestReplaceSkill)]
	[ProtoContract]
	public partial class C2M_TestReplaceSkill: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long PeopleId { get; set; }

		[ProtoMember(2)]
		public int OldSkillId { get; set; }

		[ProtoMember(3)]
		public int NewSkillId { get; set; }

	}

	[Message(OuterOpcode.M2C_TestReplaceSkill)]
	[ProtoContract]
	public partial class M2C_TestReplaceSkill: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[Message(OuterOpcode.MonsterGroupProto)]
	[ProtoContract]
	public partial class MonsterGroupProto: Object
	{
		[ProtoMember(1)]
		public long Id { get; set; }

		[ProtoMember(2)]
		public int ConfigId { get; set; }

		[ProtoMember(3)]
		public int Seed { get; set; }

		[ProtoMember(4)]
		public float X { get; set; }

		[ProtoMember(5)]
		public float Y { get; set; }

		[ProtoMember(6)]
		public long ResId { get; set; }

		[ProtoMember(7)]
		public int RefreshType { get; set; }

		[ProtoMember(8)]
		public int RefreshParm { get; set; }

	}

	[ResponseType(nameof(M2C_RepairBuilding))]
	[Message(OuterOpcode.C2M_RepairBuilding)]
	[ProtoContract]
	public partial class C2M_RepairBuilding: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long PeopleId { get; set; }

		[ProtoMember(2)]
		public long Id { get; set; }

	}

	[Message(OuterOpcode.M2C_RepairBuilding)]
	[ProtoContract]
	public partial class M2C_RepairBuilding: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[Message(OuterOpcode.M2C_NotifyResourceAttri)]
	[ProtoContract]
	public partial class M2C_NotifyResourceAttri: Object, IActorMessage
	{
		[ProtoMember(1)]
		public List<long> IdList = new List<long>();

		[ProtoMember(2)]
		public List<int> Ks = new List<int>();

		[ProtoMember(3)]
		public List<int> Vs = new List<int>();

	}

	[ResponseType(nameof(M2C_BuildingDurable))]
	[Message(OuterOpcode.C2M_BuildingDurable)]
	[ProtoContract]
	public partial class C2M_BuildingDurable: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long PeopleId { get; set; }

		[ProtoMember(2)]
		public long BuildingId { get; set; }

	}

	[Message(OuterOpcode.M2C_BuildingDurable)]
	[ProtoContract]
	public partial class M2C_BuildingDurable: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public List<long> IdList = new List<long>();

		[ProtoMember(2)]
		public List<int> Vs = new List<int>();

	}

	[ResponseType(nameof(M2C_ConstructFinish))]
	[Message(OuterOpcode.C2M_ConstructFinish)]
	[ProtoContract]
	public partial class C2M_ConstructFinish: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long ConstructId { get; set; }

	}

	[Message(OuterOpcode.M2C_ConstructFinish)]
	[ProtoContract]
	public partial class M2C_ConstructFinish: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[Message(OuterOpcode.FarmlandProto)]
	[ProtoContract]
	public partial class FarmlandProto: Object
	{
		[ProtoMember(1)]
		public long Id { get; set; }

		[ProtoMember(2)]
		public int CropCfgId { get; set; }

		[ProtoMember(3)]
		public int PlantCfgId { get; set; }

		[ProtoMember(4)]
		public int Duration { get; set; }

		[ProtoMember(5)]
		public int ExProduct { get; set; }

		[ProtoMember(6)]
		public int FarmlandState { get; set; }

		[ProtoMember(7)]
		public long PeopleId { get; set; }

		[ProtoMember(8)]
		public long CabinId { get; set; }

	}

	[ResponseType(nameof(M2C_FarmlandPlant))]
	[Message(OuterOpcode.C2M_FarmlandPlant)]
	[ProtoContract]
	public partial class C2M_FarmlandPlant: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long FarmlandId { get; set; }

		[ProtoMember(2)]
		public long PeopleId { get; set; }

	}

	[Message(OuterOpcode.M2C_FarmlandPlant)]
	[ProtoContract]
	public partial class M2C_FarmlandPlant: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_FarmlandHarvest))]
	[Message(OuterOpcode.C2M_FarmlandHarvest)]
	[ProtoContract]
	public partial class C2M_FarmlandHarvest: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long FarmlandId { get; set; }

		[ProtoMember(2)]
		public long PeopleId { get; set; }

	}

	[Message(OuterOpcode.M2C_FarmlandHarvest)]
	[ProtoContract]
	public partial class M2C_FarmlandHarvest: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_FarmlandSeed))]
	[Message(OuterOpcode.C2M_FarmlandSeed)]
	[ProtoContract]
	public partial class C2M_FarmlandSeed: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long FarmlandId { get; set; }

		[ProtoMember(2)]
		public int CropCfgId { get; set; }

	}

	[Message(OuterOpcode.M2C_FarmlandSeed)]
	[ProtoContract]
	public partial class M2C_FarmlandSeed: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_ChangeBehave))]
	[Message(OuterOpcode.C2M_ChangeBehave)]
	[ProtoContract]
	public partial class C2M_ChangeBehave: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long TargetId { get; set; }

		[ProtoMember(2)]
		public int BehaveType { get; set; }

		[ProtoMember(3)]
		public long PeopleId { get; set; }

	}

	[Message(OuterOpcode.M2C_ChangeBehave)]
	[ProtoContract]
	public partial class M2C_ChangeBehave: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_CheatItemList))]
	[Message(OuterOpcode.C2M_CheatItemList)]
	[ProtoContract]
	public partial class C2M_CheatItemList: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public List<int> ConfigIds = new List<int>();

		[ProtoMember(2)]
		public List<int> Nums = new List<int>();

	}

	[Message(OuterOpcode.M2C_CheatItemList)]
	[ProtoContract]
	public partial class M2C_CheatItemList: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_GoFarmlandPlant))]
	[Message(OuterOpcode.C2M_GoFarmlandPlant)]
	[ProtoContract]
	public partial class C2M_GoFarmlandPlant: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long FarmlandId { get; set; }

		[ProtoMember(2)]
		public long PeopleId { get; set; }

	}

	[Message(OuterOpcode.M2C_GoFarmlandPlant)]
	[ProtoContract]
	public partial class M2C_GoFarmlandPlant: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_GoFarmlandHarvest))]
	[Message(OuterOpcode.C2M_GoFarmlandHarvest)]
	[ProtoContract]
	public partial class C2M_GoFarmlandHarvest: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long FarmlandId { get; set; }

		[ProtoMember(2)]
		public long PeopleId { get; set; }

	}

	[Message(OuterOpcode.M2C_GoFarmlandHarvest)]
	[ProtoContract]
	public partial class M2C_GoFarmlandHarvest: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_FarmlandRipe))]
	[Message(OuterOpcode.C2M_FarmlandRipe)]
	[ProtoContract]
	public partial class C2M_FarmlandRipe: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long FarmlandId { get; set; }

	}

	[Message(OuterOpcode.M2C_FarmlandRipe)]
	[ProtoContract]
	public partial class M2C_FarmlandRipe: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[Message(OuterOpcode.M2C_NtfFarmlandRipe)]
	[ProtoContract]
	public partial class M2C_NtfFarmlandRipe: Object, IActorMessage
	{
		[ProtoMember(1)]
		public List<long> FarmlandIds = new List<long>();

	}

	[Message(OuterOpcode.M2C_NtfFarmlandRipeProgress)]
	[ProtoContract]
	public partial class M2C_NtfFarmlandRipeProgress: Object, IActorMessage
	{
		[ProtoMember(1)]
		public List<long> FarmlandIds = new List<long>();

		[ProtoMember(2)]
		public List<int> Progresses = new List<int>();

	}

	[Message(OuterOpcode.CabinProto)]
	[ProtoContract]
	public partial class CabinProto: Object
	{
		[ProtoMember(1)]
		public long Id { get; set; }

		[ProtoMember(2)]
		public long PeopleId { get; set; }

		[ProtoMember(3)]
		public List<long> FarmlandIds = new List<long>();

		[ProtoMember(4)]
		public int ResidentState { get; set; }

	}

	[ResponseType(nameof(M2C_GoCabin))]
	[Message(OuterOpcode.C2M_GoCabin)]
	[ProtoContract]
	public partial class C2M_GoCabin: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long PeopleId { get; set; }

		[ProtoMember(2)]
		public long CabinId { get; set; }

	}

	[Message(OuterOpcode.M2C_GoCabin)]
	[ProtoContract]
	public partial class M2C_GoCabin: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_ArriveCabin))]
	[Message(OuterOpcode.C2M_ArriveCabin)]
	[ProtoContract]
	public partial class C2M_ArriveCabin: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long PeopleId { get; set; }

		[ProtoMember(2)]
		public long CabinId { get; set; }

	}

	[Message(OuterOpcode.M2C_ArriveCabin)]
	[ProtoContract]
	public partial class M2C_ArriveCabin: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_CabinAddFarmland))]
	[Message(OuterOpcode.C2M_CabinAddFarmland)]
	[ProtoContract]
	public partial class C2M_CabinAddFarmland: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public List<long> FarmlandIds = new List<long>();

		[ProtoMember(2)]
		public long CabinId { get; set; }

	}

	[Message(OuterOpcode.M2C_CabinAddFarmland)]
	[ProtoContract]
	public partial class M2C_CabinAddFarmland: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

		[ProtoMember(1)]
		public List<long> FarmlandIds = new List<long>();

	}

	[ResponseType(nameof(M2C_CabinSeed))]
	[Message(OuterOpcode.C2M_CabinSeed)]
	[ProtoContract]
	public partial class C2M_CabinSeed: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long FarmlandId { get; set; }

		[ProtoMember(2)]
		public int CropCfgId { get; set; }

	}

	[Message(OuterOpcode.M2C_CabinSeed)]
	[ProtoContract]
	public partial class M2C_CabinSeed: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_CabinUpdateFarmlands))]
	[Message(OuterOpcode.C2M_CabinUpdateFarmlands)]
	[ProtoContract]
	public partial class C2M_CabinUpdateFarmlands: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public List<long> FarmlandIds = new List<long>();

		[ProtoMember(2)]
		public long CabinId { get; set; }

	}

	[Message(OuterOpcode.M2C_CabinUpdateFarmlands)]
	[ProtoContract]
	public partial class M2C_CabinUpdateFarmlands: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[ResponseType(nameof(M2C_CabinHarvest))]
	[Message(OuterOpcode.C2M_CabinHarvest)]
	[ProtoContract]
	public partial class C2M_CabinHarvest: Object, IActorLocationRequest
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(1)]
		public long FarmlandId { get; set; }

	}

	[Message(OuterOpcode.M2C_CabinHarvest)]
	[ProtoContract]
	public partial class M2C_CabinHarvest: Object, IActorLocationResponse
	{
		[ProtoMember(90)]
		public int RpcId { get; set; }

		[ProtoMember(91)]
		public int Error { get; set; }

		[ProtoMember(92)]
		public string Message { get; set; }

	}

	[Message(OuterOpcode.WeatherProto)]
	[ProtoContract]
	public partial class WeatherProto: Object
	{
		[ProtoMember(1)]
		public long Id { get; set; }

		[ProtoMember(2)]
		public int ConfigId { get; set; }

		[ProtoMember(3)]
		public int State { get; set; }

	}

	[Message(OuterOpcode.M2C_NtfWeatherStart)]
	[ProtoContract]
	public partial class M2C_NtfWeatherStart: Object, IActorMessage
	{
		[ProtoMember(1)]
		public int WeatherCfgId { get; set; }

	}

	[Message(OuterOpcode.M2C_NtfWeatherEnd)]
	[ProtoContract]
	public partial class M2C_NtfWeatherEnd: Object, IActorMessage
	{
		[ProtoMember(1)]
		public int WeatherCfgId { get; set; }

	}

}
