﻿using FairyGUI;

namespace ET
{
    public class BattleUnitItem : GButton
    {
        public GTextField _Name;
        public SkillButton SkillButton1;
        public SkillButton SkillButton2;
        public GProgressBar ManaProgressBar;
        private GLoader _Icon;
        private Controller _DieController;
        

        public override void ConstructFromXML(FairyGUI.Utils.XML cxml)
        {
            base.ConstructFromXML(cxml);

            this._Name = this.GetChild("Name").asTextField;
            this._Icon = this.GetChild("HeadIcon").asLoader;
            this.SkillButton1 = (SkillButton)this.GetChild("SkillButton1").asButton;
            this.SkillButton2 = (SkillButton)this.GetChild("SkillButton2").asButton;
            this.ManaProgressBar = this.GetChild("ManaProgressBar").asProgress;
            this._DieController = this.GetController("Die");
        }

        public void SetName(string name)
        {
            this._Name.text = name;
        }

        public void SetIcon(string url)
        {
            this._Icon.url = url;
        }

        public void SetDead(bool dead)
        {
            if (dead)
            {
                this._DieController.selectedIndex = 1;
            }
            else
            {
                this._DieController.selectedIndex = 0;
            }
        }
    }
}