﻿using System;
using FairyGUI;

namespace ET
{
    public class BuildingWorkerItem : GButton
    {
        private GTextField _NameText;
        private GLoader _Icon;
        private GTextField _Strength;
        private GTextField _State;
        public GButton WorkCheckBox;
        private Controller _workCtrl;

        public override void ConstructFromXML(FairyGUI.Utils.XML cxml)
        {
            base.ConstructFromXML(cxml);

            this._NameText = this.GetChild("Name").asTextField;
            this._Icon = this.GetChild("HeadIcon").asLoader;
            this._Strength = this.GetChild("Strength").asTextField;
            this._State = this.GetChild("State").asTextField;
            this.WorkCheckBox = this.GetChild("WorkCheckBox").asButton;
            this._workCtrl = this.WorkCheckBox.GetController("isWorkingOthers");
        }
        
        public void SetName(string name)
        {
            this._NameText.text = name;
        }

        public void SetIcon(string url)
        {
            this._Icon.url = url;
        }

        public void SetStrength(int value)
        {
            this._Strength.text = value.ToString();
        }

        public void SetStateMsg(string msg)
        {
            this._State.text = msg;
        }

        public Controller GetWorkingController()
        {
            return this._workCtrl;
        }
    }
}