﻿using FairyGUI;
using FairyGUI.Utils;

namespace ET
{
    public class FoodItem : GButton
    {
        private GLoader m_Icon;
        private GTextField m_Num;

        public override void ConstructFromXML(XML xml)
        {
            base.ConstructFromXML(xml);

            this.m_Icon = this.GetChild("Icon").asLoader;
            this.m_Num = this.GetChild("Num").asTextField;
        }

        public void SetIcon(string value)
        {
            if (string.IsNullOrEmpty(value))
            {
                this.m_Icon.url = null;
                return;
            }
            this.m_Icon.url = $"ui://AllItem/{value}";
        }

        public void SetNum(long value)
        {
            this.m_Num.text = value.ToString();
        }
    }
}
