﻿using FairyGUI;
using FairyGUI.Utils;

namespace ET
{
    public class LineupPeopleItem: GButton
    {
        private GTextField _NameText;
        private GLoader _Icon;
        private GTextField _FightPointText;
        private GTextField _LineupSeatText;
        private Controller _IsInLineupCtrl;

        public override void ConstructFromXML(XML cxml)
        {
            base.ConstructFromXML(cxml);
            this._NameText = this.GetChild("Name").asTextField;
            this._Icon = this.GetChild("Icon").asLoader;
            this._FightPointText = this.GetChild("FightPoint").asTextField;
            this._LineupSeatText = this.GetChild("LineupSeat").asTextField;
            _IsInLineupCtrl = this.GetController("isInLineup");
        }

        public void SetName(string name)
        {
            this._NameText.text = name;
        }

        public void SetIcon(string url)
        {
            this._Icon.url = url;
        }
        
        public GLoader GetIcon()
        {
            return this._Icon;
        }

        public string GetIconUrl()
        {
            return this._Icon.url;
        }

        public void SetFightPoint(int point)
        {
            this._FightPointText.text = point.ToString();
        }

        public void SetLineupSeat(int pos)
        {
            if (pos > 0)
            {
                this._IsInLineupCtrl.selectedIndex = 1;
                this._LineupSeatText.text = pos.ToString();
            }
            else
            {
                this._IsInLineupCtrl.selectedIndex = 0;
            }
        }
    }
}
