﻿using FairyGUI;
using FairyGUI.Utils;

namespace ET
{
    public class LineupSeatItem: GButton
    {
        private GTextField _NameText;
        private GLoader _Icon;
        public GButton CancelButton;
        private Controller _HasPeopleCtrl;
        private long _PeopleId;

        public override void ConstructFromXML(XML cxml)
        {
            base.ConstructFromXML(cxml);
            this._NameText = this.GetChild("Name").asTextField;
            this._Icon = this.GetChild("Icon").asLoader;
            this.CancelButton = this.GetChild("CancelButton").asButton;
            this._HasPeopleCtrl = this.GetController("hasPeople");
        }

        public void SetName(string name)
        {
            this._NameText.text = name;
        }

        public void SetIcon(string url)
        {
            this._Icon.url = url;
        }
        
        public GLoader GetIcon()
        {
            return this._Icon;
        }

        public void SetHasPeople(bool hasPeople)
        {
            this._HasPeopleCtrl.selectedIndex = hasPeople? 1 : 0;
        }

        public bool HasPeople()
        {
            return this._HasPeopleCtrl.selectedIndex == 1;
        }

        public long GetPeopleId()
        {
            return this._PeopleId;
        }

        public void SetPeople(long peopleId)
        {
            this._PeopleId = peopleId;
            SetHasPeople(true);
        }

        public void ClearPeople()
        {
            this._PeopleId = 0;
            SetHasPeople(false);
        }
    }
}
