﻿using FairyGUI;
using UnityEngine;

namespace ET
{
    public class PeopleItem : GButton
    {
        private GTextField _NameText;
        private GTextField _StrengthText;
        private GTextField _AgeText;
        private GGraph _AvatarHolder;
        private GoWrapper _AvatarWrapper;

        public override void ConstructFromXML(FairyGUI.Utils.XML cxml)
        {
            base.ConstructFromXML(cxml);

            this._NameText = this.GetChild("Name").asTextField;
            this._StrengthText = this.GetChild("Strength").asTextField;
            this._AgeText = this.GetChild("Age").asTextField;
            this._AvatarHolder = this.GetChild("Avatar").asGraph;
        }

        public void SetName(string name)
        {
            this._NameText.text = name;
        }

        public void SetStrength(int value)
        {
            this._StrengthText.text = value.ToString();
        }

        public void SetAge(int value)
        {
            this._AgeText.text = value.ToString();
        }
        
        public void SetAvatar(GameObject go)
        {
            if (this._AvatarWrapper == null)
            {
                this._AvatarWrapper = new GoWrapper(go);
                this._AvatarHolder.SetNativeObject(this._AvatarWrapper);
            }
            else
            {
                this._AvatarWrapper.wrapTarget.SetActive(false);
                this._AvatarWrapper.wrapTarget = go;
                go.SetActive(true);
            }
        }
    }
}