﻿using FairyGUI;

namespace ET
{
    public class ProduceItem : GButton
    {
        private GLoader _Icon;
        private Controller _DropRateCtrl;
        private GTextField _DropNum;
        
        public override void ConstructFromXML(FairyGUI.Utils.XML cxml)
        {
            base.ConstructFromXML(cxml);

            this._Icon = this.GetChild("Icon").asLoader;
            this._DropRateCtrl = this.GetController("DropRateType");
            this._DropNum = this.GetChild("DropNum").asTextField;
        }

        public void SetIcon(string url)
        {
            this._Icon.url = url;
        }

        public void SetDropRate(int type)
        {
            this._DropRateCtrl.selectedIndex = type;
        }

        public void SetDropNum(int num)
        {
            this._DropNum.text = num.ToString();
        }
    }
}