﻿using FairyGUI;
using FairyGUI.Utils;

namespace ET
{
    public class SynthesisItem : GButton
    {
        private GLoader m_Icon;
        private GTextField m_Name;
        private GTextField m_OwnNum;
        private GTextField m_makableNum;

        public override void ConstructFromXML(XML xml)
        {
            base.ConstructFromXML(xml);

            this.m_Icon = this.GetChild("Icon").asLoader;
            this.m_Name = this.GetChild("Name").asTextField;
            this.m_OwnNum = this.GetChild("OwnNum").asTextField;
            this.m_makableNum = this.GetChild("Amount").asTextField;
        }

        public void SetIcon(string url)
        {
            this.m_Icon.url = $"ui://AllItem/{url}";
        }

        public void SetName(string name)
        {
            this.m_Name.text = name;
        }

        public void SetAmount(string value)
        {
            this.m_makableNum.text = $"[color=#33FF00]{value}[/color]";
        }
        
        public void SetOwnNum(string value)
        {
            this.m_OwnNum.SetVar("count", value).FlushVars();
        }
    }
}
