﻿using System.Collections.Generic;
using FairyGUI;

namespace ET
{


	/// <summary>
	/// 管理所有顶层UI, 顶层UI都是GRoot的孩子
	/// </summary>
	[ComponentOf(typeof(Scene))]
	public class FUIComponent: Entity, IAwake, IDestroy
	{
		public static FUIComponent Instance { get; set; }
		public FUI Root;
		public Dictionary<string, IFUIWindow> AvailableWindows = new Dictionary<string, IFUIWindow>();
		public Dictionary<string, Entity> AvailableUI = new Dictionary<string, Entity>();
		public bool IsButtonClicked { get; set; }
		public long ButtonAsyncEventTimer = 0;
	}
}